use File::Copy;
use AnyEvent::HTTP;

my $extensions_file = $main::pluginconfig{'phonepro'}{'asterisk_extensions_conf_file'}{''};
my $phonepro_file   = $main::pluginconfig{'phonepro'}{'chatbroker_conf_file'}{''};
my $plugin_path     = $main::pluginconfig{'phonepro'}{'plugin_path'}{''};
my $maintenance_url = $main::pluginconfig{'phonepro'}{'maintenance_url'}{''};

$phonepro_generated_dialplan=0;

my $phonepro_attempt_renew_days = 3;
my $phonepro_day = 86400;

#$phonepro_attempt_renew_days = 1;
#$phonepro_day = 10;

my $renew_interval = $phonepro_attempt_renew_days * $phonepro_day;
$main::directclientcmd{'DELIVERYFAIL'}=1;

my $agidir = get_agi_directory();

if(! -f "$agidir/chatbroker.agi") {

    main::log_debug("** PhonePRO: ChatBroker: copying AGI script from $plugin_path/phonepro/agi-bin/chatbroker.agi to $agidir/chatbroker.agi", 32) if main::DEBUG;
    copy("$plugin_path/phonepro/agi-bin/chatbroker.agi","$agidir/chatbroker.agi");
    chmod 0755, "$agidir/chatbroker.agi";

} else {

    open FILE, "$agidir/chatbroker.agi";
    my $ctx = main::Digest::MD5->new;
    $ctx->addfile(*FILE);
    my $hash1 = $ctx->digest;
    close FILE;

    open FILE, "$plugin_path/phonepro/agi-bin/chatbroker.agi";
    my $ctx = main::Digest::MD5->new;
    $ctx->addfile(*FILE);
    my $hash2 = $ctx->digest;
    close FILE;

    if($hash1 ne $hash2) {
        main::log_debug("** PhonePRO: ChatBroker: upgrading AGI script", 32) if main::DEBUG;
        copy("$plugin_path/phonepro/agi-bin/chatbroker.agi","$agidir/chatbroker.agi");
        chmod 0755, "$agidir/chatbroker.agi";
    }
}

sub get_agi_directory() {
    my $file = '/etc/asterisk/asterisk.conf';
    open my $info, $file or return "/var/lib/asterisk/agi-bin";

    while( my $line = <$info>)  {
        if ( $line =~ /astagidir/ ) {
           my @partes = split(/=>/,$line);
           $return = $partes[1];
           break;
        }
    }
    close $info;
    $return =~ s/\s+//g;
    return $return;
}

sub phonepro_dialplan() {

    my %data;
    my %data2;

#my $send_text='s,1,Noop(Sending Text to: ${ARG1})
#s,n,While($["${SET(var=${POP(MESSAGE_DATA(Via),\;)})}" != ""])
#s,n,Set(SIPVAR=${CUT(var,=,1)})
#s,n,Set(SIPVAL=${CUT(var,=,2)})
#s,n,ExecIf($["${SIPVAR}"="branch"]?Set(BRANCH=${SIPVAL}))
#s,n,EndWhile
#s,n,Set(PEER=${CUT(CUT(CUT(MESSAGE(from),@,1),<,2),:,2)})
#s,n,Noop(Peer ${PEER})
#s,n,Set(FROM=${DB(AMPUSER/${PEER}/cidname)})
#s,n,Set(CALLERID_NUM=${DB(AMPUSER/${PEER}/cidnum)})
#s,n,Set(DIAL=${DB(DEVICE/${PEER}/dial)})
#s,n,Set(TECH=${TOLOWER(${CUT(DIAL,/,1)})})
#s,n,Set(FROM_SIP=${STRREPLACE(MESSAGE(from),<sip:${PEER}@,<sip:${CALLERID_NUM}@)})
#s,n,Set(MESSAGE(custom_data)=mark_all_outbound)
#s,n,MessageSend(${TECH}:${ARG1}, ${FROM_SIP})
#s,n,GotoIf($["${MESSAGE_SEND_STATUS}" != "SUCCESS"]?sendfailedmsg)
#s,n,Hangup
#s,n(sendfailedmsg),NoOp(Sending error to user)
#s,n,Set(SRC=${MESSAGE(from)})
#s,n,Set(DST=${MESSAGE(to)})
#s,n,Set(MSG=${MESSAGE(body)})
#s,n,Set(MESSAGE(body)="[${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)}] Your message to ${ARG1} has failed. Sending when available")
#s,n,Set(ME_1=${CUT(MESSAGE(from),<,2)})
#s,n,Set(ACTUALFROM=${TECH}:${PEER})
#s,n,MessageSend(${ACTUALFROM},ServiceCenter)
#s,n,UserEvent(DELIVERYFAIL,Value: ${BRANCH},Channel:${TECH}/${PEER},Family:DELIVERYFAIL)
#s,n,GotoIf($["${INQUEUE}" != "1"]?startq)
#s,n,Hangup()
#s,n(startq),NoOp(Queueing messaging for offline)
#s,n,Set(MSGTIME=${STRFTIME(${EPOCH},,%d%m%Y-%H:%M:%S)})
#s,n,Hangup()[app-fakeanswer]
#s,1,NoCDR
#s,n,Set(DESTDEV=${EXTEN})
#s,n,Set(THISDEVSTATE=${DEVICE_STATE(SIP/${DESTDEV})})
#s,n,GotoIf($["${THISDEVSTATE}" = "UNAVAILABLE"]?hang)
#s,n,GotoIf($["${THISDEVSTATE}" = "UNKNOWN"]?hang)
#s,n,Answer
#s,n,Hangup()
#s,n(hang),Hangup()';

#my $external_sms='s,1,Noop((Sending External Text To: ${ARG1})
#s,n,While($["${SET(var=${POP(MESSAGE_DATA(Via),\;)})}" != ""])
#s,n,Set(SIPVAR=${CUT(var,=,1)})
#s,n,Set(SIPVAL=${CUT(var,=,2)})
#s,n,ExecIf($["${SIPVAR}"="branch"]?Set(BRANCH=${SIPVAL}))
#s,n,Noop(Outbound message branch ${BRANCH})
#s,n,Set(PEER=${CUT(CUT(CUT(MESSAGE(from),@,1),<,2),:,2)})
#s,n,AGI(chatbroker.agi,${PEER},${MESSAGE(to)},"${MESSAGE(body)}",${MESSAGE_DATA(X-Queue-Id)})';

my $external_sms='s,1,Noop(Sending External Text To: ${ARG1})
s,n,While($["${SET(var=${POP(MESSAGE_DATA(Via),\;)})}" != ""])
s,n,Set(SIPVAR=${CUT(var,=,1)})
s,n,Set(SIPVAL=${CUT(var,=,2)})
s,n,ExecIf($["${SIPVAR}"="branch"]?Set(BRANCH=${SIPVAL}))
s,n,EndWhile
s,n,Noop(Outbound message branch ${BRANCH})
s,n,Set(PEER=${CUT(CUT(CUT(MESSAGE(from),@,1),<,2),:,2)})
s,n,Set(CALLERID_NUM=${DB(AMPUSER/${PEER}/cidnum)})
s,n,Noop(Peer ${PEER})
s,n,AGI(chatbroker.agi,${PEER},${MESSAGE(to)},"${MESSAGE(body)}",${MESSAGE_DATA(X-Queue-Id)})
s,n,GotoIf($["${DO_MESSAGESEND}" == "1"]?send)
s,n,Hangup
s,n(send),Set(FROM_SIP=${STRREPLACE(MESSAGE(from),<sip:${PEER}@,<sip:${CALLERID_NUM}@)})
s,n,MessageSend(${DESTINATION},${FROM_SIP})
s,n,GotoIf($["${MESSAGE_SEND_STATUS}" != "SUCCESS"]?sendfailedmsg)
s,n,Hangup
s,n(sendfailedmsg),DumpChan
s,n,Set(DIAL=${DB(DEVICE/${PEER}/dial)})
s,n,Set(TECH=${TOLOWER(${CUT(DIAL,/,1)})})
s,n,UserEvent(DELIVERYFAIL,Value: ${BRANCH},Channel:${TECH}/${PEER},Family:DELIVERYFAIL)
s,n,Hangup';

#; testing context
#;s,n,Set(FCONTEXT=tenant1)
#;s,n,ExecIf($["${PEER}" = "202"]?Set(FCONTEXT=tenant2))
#;s,n,ExecIf($["${PEER}" = "203"]?Set(FCONTEXT=tenant2))
#;s,n,ExecIf($["${PEER}" = "212"]?Set(FCONTEXT=tenant2))
#;s,n,ExecIf($["${PEER}" = "213"]?Set(FCONTEXT=tenant2))
#; end testing context


my $external_sms='s,1,Noop(Sending Text To: ${ARG1})
s,n,While($["${SET(var=${POP(MESSAGE_DATA(Via),\\;)})}" != ""])
s,n,Set(SIPVAR=${CUT(var,=,1)})
s,n,Set(SIPVAL=${CUT(var,=,2)})
s,n,ExecIf($["${SIPVAR}"="branch"]?Set(BRANCH=${SIPVAL}))
s,n,EndWhile
s,n,Noop(Outbound message branch ${BRANCH})
s,n,Noop(From ${MESSAGE(from)})
s,n,Set(PEER=${CUT(CUT(CUT(MESSAGE(from),@,1),<,2),:,2)})
s,n,Set(FCONTEXT=${CUT(PEER,-,2)})
s,n,Set(CALLERID_NUM=${DB(AMPUSER/${PEER}/cidnum)})
s,n,ExecIf($["${CALLERID_NUM}" = ""]?Set(CALLERID_NUM=${PEER}))
s,n,Noop(Peer ${PEER})
s,n,Noop(CallerID ${CALLERID_NUM})
s,n,Noop(Context ${FCONTEXT})
s,n,AGI(chatbroker.agi,${PEER},${MESSAGE(to)},"${MESSAGE(body)}",${MESSAGE_DATA(X-Queue-Id)},${FCONTEXT},${MESSAGE_DATA(X-Channel)})
s,n,GotoIf($["${DO_MESSAGESEND}" == "1"]?send)
s,n,Return
s,n(send),Set(FROM_SIP=${STRREPLACE(MESSAGE(from),<sip:${PEER}@,<sip:${CALLERID_NUM}@)})
s,n,MessageSend(${DESTINATION},${FROM_SIP})
s,n,GotoIf($["${MESSAGE_SEND_STATUS}" != "SUCCESS"]?sendfailedmsg)
s,n,Return
s,n(sendfailedmsg),Noop(send delivery fail notification)
s,n,Set(DIAL=${DB(DEVICE/${PEER}/dial)})
s,n,Set(TECH=${TOLOWER(${CUT(DIAL,/,1)})})
s,n,UserEvent(DELIVERYFAIL,Value: ${BRANCH},Channel:${TECH}/${PEER},Family:DELIVERYFAIL)
s,n,Return
';

    $data{"Action"}='updateconfig';
    $data{"Reload"}='no';
    $data{"SrcFilename"}="$phonepro_file";
    $data{"DstFilename"}="$phonepro_file";
    $data{"Action-000000"}='newcat';
    $data{"Cat-000000"}='chatbroker';
    
#    my $btn_cfg = main::get_btn_config();
    my $i = 1;
#    foreach my $ctx ( keys( %{$btn_cfg} ) ) {
#        my @pepi = @{ $btn_cfg->{$ctx} };
#        foreach my $cadauno (@pepi) {
#            my $catnum = sprintf("%06d",$i);
#            if ( defined( $cadauno->{TYPE} ) ) {
#                if ($cadauno->{TYPE} =~ m/extension/i) {
#                   my $exten = $cadauno->{EXTENSION};
#                   $data{"Action-$catnum"}='append';
#                   $data{"Cat-$catnum"}='chatbroker';
#                   $data{"Var-$catnum"}='exten';
#                   #$data{"Value-$catnum"}="$exten,1,Gosub(send-text,s,1($exten))";
#                   $data{"Value-$catnum"}="$exten,1,Gosub(chatbroker-msg,s,1($exten))";
#                   $i++;
#                   $catnum = sprintf("%06d",$i);
#                   $data{"Action-$catnum"}='append';
#                   $data{"Cat-$catnum"}='chatbroker';
#                   $data{"Var-$catnum"}='exten';
#                   $data{"Value-$catnum"}="$exten,2,Hangup";
#                   $i++;
#                }
#            }
#        }
#    }
    $catnum = sprintf("%06d",$i);
    $data{"Action-$catnum"}='append';
    $data{"Cat-$catnum"}='chatbroker';
    $data{"Var-$catnum"}='exten';
    $data{"Value-$catnum"}="_.,1,Gosub(chatbroker-msg,s,1(\${EXTEN}))";
    $i++;
 
    $catnum = sprintf("%06d",$i);
    $data{"Action-$catnum"}='append';
    $data{"Cat-$catnum"}='chatbroker';
    $data{"Var-$catnum"}='exten';
    $data{"Value-$catnum"}="_.,2,Hangup";
    $i++;

    $catnum = sprintf("%06d",$i);
    $data{"Action-$catnum"}='append';
    $data{"Cat-$catnum"}='chatbroker';
    $data{"Var-$catnum"}='exten';
    $data{"Value-$catnum"}="e,1,Hangup";

    #$data2{"Action"}='updateconfig';
    #$data2{"Reload"}='yes';
    #$data2{"SrcFilename"}="$phonepro_file";
    #$data2{"DstFilename"}="$phonepro_file";
    #$data2{"Action-000000"}='newcat';
    #$data2{"Cat-000000"}='send-text';

    if($phonepro_generated_dialplan==0) {
        $phonepro_generated_dialplan=1;

        foreach my $manager_host ( keys %main::managers ) {

            if ( $main::astman{$manager_host}->{LOGGEDIN} ) {

                phonepro_send_command_to_manager( $main::astman{$manager_host}, {
                      Action      => 'updateconfig',
                      Reload      => 'no',
                      SrcFilename => "$phonepro_file",
                      DstFilename => "$phonepro_file",
                      "Action-000000" => 'delcat',
                      "Cat-000000" => 'chatbroker'
                }, "phoneproDIALPLAN!a!a" );

                phonepro_send_command_to_manager( $main::astman{$manager_host}, \%data, "phoneproDIALPLAN!a!a" );

                phonepro_send_command_to_manager( $main::astman{$manager_host}, {
                      Action      => 'updateconfig',
                      Reload      => 'no',
                      SrcFilename => "$phonepro_file",
                      DstFilename => "$phonepro_file",
                      "Action-000000" => 'delcat',
                      "Cat-000000" => 'send-text'
                }, "phoneproDIALPLAN!a!a" );

                phonepro_send_command_to_manager( $main::astman{$manager_host}, \%data2, "phoneproDIALPLAN!a!a" );

                #%data2={};
                #my @lines = split(/\n/,$send_text);
                #$i=0;
                #my $notdone=1;
                #$data2{'Action'}='updateconfig';
                #$data2{'Reload'}='no';
                #$data2{'SrcFilename'}="$phonepro_file";
                #$data2{'DstFilename'}="$phonepro_file";

                #foreach(@lines) {
                #    my $catnum = sprintf("%06d",$i);
                #    $data2{"Action-$catnum"}='append';
                #    $data2{"Cat-$catnum"}='send-text';
                #    $data2{"Var-$catnum"}='exten';
                #    $data2{"Value-$catnum"}=$_;
                #    $i++;
                #    if($i%10==0) {
                #        phonepro_send_command_to_manager( $main::astman{$manager_host}, \%data2, "phoneproDIALPLAN!a!a" );
                #        %data2 = {};
                #        $data2{'Action'}='updateconfig';
                #        $data2{'Reload'}='no';
                #        $data2{'SrcFilename'}="$phonepro_file";
                #        $data2{'DstFilename'}="$phonepro_file";
                #        $i=0;
                #        $notdone=0;
                #    } else {
                #        $notdone=1;
                #    }
                #}
                #if($notdone==1) {
                #    phonepro_send_command_to_manager( $main::astman{$manager_host}, \%data2, "phoneproDIALPLAN!a!a" );
                #}

                phonepro_send_command_to_manager( $main::astman{$manager_host}, {
                      Action           => 'updateconfig',
                      Reload           => 'no',
                      SrcFilename     => "$phonepro_file",
                      DstFilename     => "$phonepro_file",
                      "Action-000000" => 'delcat',
                      "Cat-000000"    => 'chatbroker-msg',
                }, "phoneproDIALPLAN!a!a" );

                phonepro_send_command_to_manager( $main::astman{$manager_host}, {
                      Action           => 'updateconfig',
                      Reload           => 'no',
                      SrcFilename     => "$phonepro_file",
                      DstFilename     => "$phonepro_file",
                      "Action-000000" => 'newcat',
                      "Cat-000000"    => 'chatbroker-msg',
                }, "phoneproDIALPLAN!a!a" );

                %data2={};
                @lines = split(/\n/,$external_sms);
                $i=0;
                $notdone=1;
                $data2{'Action'}='updateconfig';
                $data2{'Reload'}='yes';
                $data2{'SrcFilename'}="$phonepro_file";
                $data2{'DstFilename'}="$phonepro_file";

                foreach(@lines) {
                    my $catnum = sprintf("%06d",$i);
                    $data2{"Action-$catnum"}='append';
                    $data2{"Cat-$catnum"}='chatbroker-msg';
                    $data2{"Var-$catnum"}='exten';
                    $data2{"Value-$catnum"}=$_;
                    $i++;
                    if($i%10==0) {
                        phonepro_send_command_to_manager( $main::astman{$manager_host}, \%data2, "phoneproDIALPLAN!a!a" );
                        %data2 = {};
                        $data2{'Action'}='updateconfig';
                        $data2{'Reload'}='yes';
                        $data2{'SrcFilename'}="$phonepro_file";
                        $data2{'DstFilename'}="$phonepro_file";
                        $i=0;
                        $notdone=0;
                    } else {
                        $notdone=1;
                    }
                }
                if($notdone==1) {
                    phonepro_send_command_to_manager( $main::astman{$manager_host}, \%data2, "phoneproDIALPLAN!a!a" );
                }


            }
        }
    }
};

sub phonepro_send_command_to_manager {

    my ( $asterisk, $comando, $extra ) = @_;
    if ( !defined($extra) ) { $extra = ''; }
    if ( !defined($asterisk) ) { return; }

    my $action_id = $asterisk->send_action(
        $comando,
        sub {
            my ( $asterisk, $response ) = @_;
            \&phonepro_handle_ami_response( $asterisk, $response, $extra );
        },
        3
    );

    return $action_id;
};

sub phonepro_handle_ami_response {
    my ( $asterisk, $response, $extra ) = @_;
    if($response->{Response} ne "Success") {
        main::log_debug("** PhonePRO: There was a problem generating dialplan", 16) if main::DEBUG;
    }
}
sub phonepro_schedule() {
    http_get $maintenance_url."/plugins/phonepro/menu/api.php?action=schedule", sub { print "** PHONEPRO scheduled calls\n"; };
}

sub phonepro_garbage_collect() {
    http_get $maintenance_url."/plugins/phonepro/menu/api.php?action=gc", sub { print "** PHONEPRO garbage collect done\n"; };
}

sub phonepro_renew_license() {

    my $plugstring = $main::pluginexpirestring;
    my @plug = split(/,/,$plugstring);
    my $cuantos = $#plug + 1;
    if ( $cuantos > 0 ) {
        for ( my $i = 0 ; $i < $cuantos ; $i++ ) {
            if ($plug[$i] =~ m/\^/) {
                my @partes = split /\^/, $plug[$i];
                my ($anio,$mes,$dia) = unpack('A4 A2 A2',$partes[1]);
                if($partes[0] eq "phonepro") {
                    my $hoy    = Time::Piece->new;
                    my $expira = Time::Piece->strptime("$anio-$mes-$dia",'%Y-%m-%d');
                    my $diff = $expira - $hoy;
                    my $quedan = $diff->days;
                    if($quedan<7 && $quedan>-7) {
                        main::log_debug("** PhonePRO: attempt to renew license", 16) if main::DEBUG;
                        FOP2::License::renew('phonepro');
                    } else {
                        main::log_debug("** PhonePRO: skip license renewal because its outside renew window ($quedan days)", 16) if main::DEBUG;
                    }
                }
            }
        }
    }

}

$Client_Pre_Command_Handler{'phonepro'}{'prosipcredentials'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my @elemento;
    my $ufilter;

    my @parts        = split(/!/,$origen);
    my $pos          = $parts[0];
    my $exten        = $parts[1];
    my $mychannel    = main::get_btn_config( "$contexto", $pos, 'MAINCHANNEL');
    my $sip_user     = main::get_btn_config( "$contexto", $pos, 'SIP_USERNAME');
    my $sip_password = main::get_btn_config( "$contexto", $pos, 'SIP_PASSWORD');

    my %userplugs;
    while ( my ( $exten, $data ) = each( %{ $main::userplugins->{$contexto} } ) ) {
        $userplugs{$exten}=$data;
    }

    my $free_licenses = 2;

    # Lift free license restrinctions if plugin is licensed, with a 4 day grace period after expiration
    my $plugstring = $main::pluginexpirestring;
    print "phonepro plugin $plugstring\n";
    my @plug = split(/,/,$plugstring);
    my $cuantos = $#plug + 1;
    if ( $cuantos > 0 ) {
        for ( my $i = 0 ; $i < $cuantos ; $i++ ) {
            if ($plug[$i] =~ m/\^/) {
                my @partes = split /\^/, $plug[$i];
                my ($anio,$mes,$dia) = unpack('A4 A2 A2',$partes[1]);
                if($partes[0] eq "phonepro") {
                    my $hoy    = Time::Piece->new;
                    my $expira = Time::Piece->strptime("$anio-$mes-$dia",'%Y-%m-%d');
                    my $diff = $expira - $hoy;
                    my $quedan = $diff->days;
                    if($quedan>-4) { $free_licenses=10; }
                } elsif($partes[0] eq "phoneprou") {
                    my $hoy    = Time::Piece->new;
                    my $expira = Time::Piece->strptime("$anio-$mes-$dia",'%Y-%m-%d');
                    my $diff = $expira - $hoy;
                    my $quedan = $diff->days;
                    if($quedan>-4) { $free_licenses=999999; }
                }
            }
        }
    }

    %allowed_extens = ();
    foreach my $exten (sort keys %userplugs) {
        my @allplugins = split( /,/, $userplugs{$exten} );
        @hasit = grep(/phonepro/i,@allplugins);
        my $length = @hasit;
        if($length>0 && $free_licenses>0) {
            $allowed_extens{$exten}=1;
            $free_licenses--;
        }
    }

    if(exists $allowed_extens{$exten}) {
        my $returnjson64 = FOP2::utils::encode_base64($sip_user."^".$sip_password);
        $return  = "Action: UserEvent\r\n";
        $return .= "UserEvent: SIPCredentials\r\n";
        $return .= "Channel: $mychannel-fakesession\r\n";
        $return .= "Family: SIPCredentials\r\n";
        $return .= "Value: $returnjson64\r\n";
        $return .= "\r\n";
        push @allreturn, $return;
    } else {
        $return  = "Action: UserEvent\r\n";
        $return .= "UserEvent: PhoneNoLicense\r\n";
        $return .= "Channel: $mychannel\r\n";
        $return .= "Family: PhoneNoLicense\r\n";
        $return .= "Value: 1\r\n";
        $return .= "\r\n";
        push @allreturn, $return;
 
    }

    my ( $demo, $whiteLabel, $reactivate, $licenseLevel ) = FOP2::License::check_license(1);
    if($licenseLevel & 2) {
        $return  = "Action: UserEvent\r\n";
        $return .= "UserEvent: PhoneproVoicemail\r\n";
        $return .= "Channel: $mychannel-fakesession\r\n";
        $return .= "Family: PhoneproVoicemail\r\n";
        $return .= "Value: 1\r\n";
        $return .= "\r\n";
        push @allreturn, $return;
    } else {
        $return  = "Action: UserEvent\r\n";
        $return .= "UserEvent: PhoneproVoicemail\r\n";
        $return .= "Channel: $mychannel-fakesession\r\n";
        $return .= "Family: PhoneproVoicemail\r\n";
        $return .= "Value: 0\r\n";
        $return .= "\r\n";
        push @allreturn, $return;
    }
    return @allreturn
};

$AMI_Event_Handler{'phonepro'}{'VOICEMAILUSERENTRYCOMPLETE'} = sub {
    my @allreturn;
    $return  = "Action: UserEvent\r\n";
    $return .= "UserEvent: PhoneMailboxes\r\n";
    $return .= "Channel: $mychannel\r\n";
    $return .= "Family: SIPCredentials\r\n";
    $return .= "Value: $returnjson64\r\n";
    $return .= "\r\n";
    push @allreturn, $return;
    return @allreturn;
};

$AMI_Event_Handler{'phonepro'}{'STATUSCOMPLETE'} = sub {

    my @allreturn;

    if($phonepro_generated_dialplan==1) {
        return;
    }

    my $uid;
    my $gid;

    if( ! -f $phonepro_file ) {
        (undef, undef, undef, undef, $uid, $gid, undef, undef, undef, undef, undef, undef) = stat ($extensions_file);
        open(my $fh,'>',$phonepro_file);
        close($fh);
        my @files = ( $phonepro_file );
        chown $uid, $gid, @files;
    }

    open my $fh, '<', $extensions_file;
    my $existe=0;
    while (my $line = <$fh>) {
        if ($line =~ /#include "$phonepro_file"/) {
            $existe=1;
        }
    }

    if ($existe==0) {
        open(my $fh, '>>', $extensions_file);
        print $fh "#include \"$phonepro_file\"\n";
        close $fh;
    }

    phonepro_dialplan();

#    $return  = "Action: VoicemailUsersList\r\n";
#    $return .= "\r\n";
#    push @allreturn, $return;

#    foreach my $manager_host ( keys %main::managers ) {
#        phonepro_send_command_to_manager( $main::astman{$manager_host}, {
#          Action      => 'VoicemailUsersList'
#        }, "voicemailuserslist!a!a" );
#    }

    return @allreturn;

};

$timer_phonepro_renew = AnyEvent->timer(
    after    => 60,
    interval => $renew_interval,
    cb       => sub {
        phonepro_renew_license();
    }
);

$timer_phonepro_garbage_collect = AnyEvent->timer(
    after    => 30,
    interval => 60,
    cb       => sub {
        phonepro_garbage_collect();
    }
);

$timer_phonepro_schedule = AnyEvent->timer(
    after    => 30,
    interval => 10,
    cb       => sub {
        phonepro_schedule();
    }
);
