var recommended_chatbroker_version = "1.0.1";
var PERSON_NAME= parent.botonitos[parent.myposition]['LABEL'];
var history_type = 'all';
var history_current_page = 1;
var myDrop;
var chatDisabled=1;
var provider_list = {};
var provider_capabilities = {};
var provider_ptt = {};
var provider_audiocall = {};
var provider_icon = {};
//var provider_group = {};
var provider_crm = {};
var provider_tags = {};
var provider_name = {};
var service_groups = {};
var quick_replies = {};
var voicemailenabled = 0;

const pocketclient = new PocketBase(window.location.protocol+'//'+window.location.host+'/realtime');

async function updateConversationTag(id,val) {
    console.log("update conversation tag",id,val);
    const record = await pocketclient.collection('incomingqueue').update(id, {
        tag: val
    });
    var visual_cue = 'blinkfail';
    if(record.tag==val) {
        visual_cue = 'blinkok';
    }

    $('#contact_'+record.chatid).attr('data-tag',val);

    $('.conversationtag').addClass(visual_cue);
    setTimeout(function() { $('.conversationtag').removeClass(visual_cue);},1000);

}

async function chatRealtime() {

    fetch('../menu/api.php?action=getVersion').then((response)=>response.json()).then((data)=> {
        if(compareVersions(data.version,recommended_chatbroker_version)=='lower') {
            parent.alertify.error("Please upgrade ChatBroker to at least version "+recommended_chatbroker_version);
        }
    });

    // only subscribe to message if having supervisor privileges
    pocketclient.collection('messages').subscribe('*', function (e) {
        if(e.action=='create') {
            var conversationid = e.record.conversation;
            var body = e.record.body;
            var msgid = e.record.id;
            var chatid = e.record.from;
            var finalfrom = e.record.name;
            var avatar = e.record.avatar;
            var direction = e.record.direction;
            if(direction=='note') {

                $('*[data-conversationid="'+conversationid+'"]').each(function() {
                    if($(this).hasClass('extencontact')) {
                         elements=$(this).attr('id').substr(8).split('_');
                         did = elements.pop();
                         chatid = elements.join('_');
                         mychan=$(this).attr('data-channel');
                         console.log('append note to active conversation id, chatid = '+chatid+", mychan="+mychan);
                         appendMessage(chatid, msgid, finalfrom, avatar, direction, body, undefined, undefined, conversationid, undefined, '', undefined, mychan, 0, did);
                    }
                });

            } else if(direction=='group' || direction=='groupagent') {
                if(direction=='group') {
                    direction='left';
                } else {
                    direction='right';
                }
                $('*[data-conversationid="'+conversationid+'"]').each(function() {
                    if($(this).hasClass('extencontact')) {
                         console.log('append group message to active conversation id');
                         elements=$(this).attr('id').substr(8).split('_');
                         did = elements.pop();
                         chatid = elements.join('_');
                         mychan=$(this).attr('data-channel');
                         appendMessage(chatid, msgid, finalfrom, avatar, direction, body, undefined, undefined, conversationid, undefined, '', undefined, mychan, 0, did);
                    }
                });
            }

            /*
            console.log("realtime message");
            console.log(e.record);
            // messages from webchat
            if($('#contact_'+e.record.from).length>0) {
                appendMessage(chatid, msgid, finalfrom, avatar, 'left', body, undefined, undefined, conversationid, 0, '', undefined, 'webchat');
                $('#msger-chat').scrollTop($('#msger-chat')[0].scrollHeight);
            }
            */

            // intercept all messages for supervisors // perhaps subscribe/unsubscribe if monitoring window is open / closed?
            if(parent.permisos.includes('supervisor') || parent.permisos.includes('all')) {
                if(e.record.direction=='inbound') { position = 'left'; } else if(e.record.direction=='outbound') { position = 'right'; } else { position = e.record.direction; }
                active_conversation = $('#chatmonitor_main').data('currentconversation');
                if(active_conversation !== undefined) {
                    if(active_conversation == conversationid) {
                        console.log('append message not a note, this is for supervisors');
                        appendMessage(chatid, msgid, finalfrom, avatar, position, body, undefined, undefined, conversationid, 2, '');
                        $('#msger-chat').scrollTop($('#msger-chat')[0].scrollHeight);
                    }
                }
            }
        }
    });

    pocketclient.collection('incomingqueue').subscribe('*', function (e) {
        // create, update, delete
        console.log("got event on incomingqueue subscription, action "+e.action);
        if(e.record.channel=='internal') { return; }

        if(e.action=='create') {
            alldata = JSON.stringify(e.record);
            if(e.record.state=='open' || e.record.state=='originate') {
                addToChatQueue(e.record.id,alldata);
                populateLastMessages();
            } else if(e.record.state=='openchannel') {
                initialOpenChannels();
            }

            // Refresh active chat table for supervisors
            if($('#chatmonitor_main table.historychat').is(':visible')===true) {
                console.log('call get chat monitor to refresh the list');
                getChatMonitor();
            } else {
                console.log('chatmonitor table.historychat no es visible no hago nada');
            }

        } else if(e.action=='update') {
            // if updated and assigned to someone, remove from pending chat list
            curstate = e.record.state;
            assigned = e.record.assignedto;
            if(curstate == 'open') {
                if(assigned == parent.myextension) {
                    // conversation is transferred
                    alldata = JSON.stringify(e.record);
                    addToChatQueue(e.record.id,alldata);
                    populateLastMessages();
                } else if(assigned=='') {
                    // remove assigned means it was transfer to ALL (queue) so anyone can continue/pickup chat
                    alldata = JSON.stringify(e.record);
                    addToChatQueue(e.record.id,alldata);
                    populateLastMessages();
                    console.log(alldata);
                    ///  contact_54911 existe? quitarlo porque me lo transfirieron a otra parte
                    if($('#contact_'+e.record.chatid+'_'+e.record.did).length==1) {
                        // disable main chat if it was active on this contact XXXXXX si e.record.chatid == selectedContact disable main chat
                        $('#contact_'+e.record.chatid+'_'+e.record.did).remove();
                        $('#chat_'+e.record.chatid+'_'+e.record.did).remove();
                        $('#chattransferto').val(null).trigger('change');
                        $('.chattransfer').hide();
                        $('#chat_contact_name').html('');
                        $('#chat_transfer_conversation').hide();
                        $('#chat_audiocall').hide();
                        $('.conversationtag').hide();
                        $('#chat_close_conversation').hide();
                        $('.enachatinput').attr('disabled','disabled');
                        $('.chatpart').addClass('disabled');
                    }
                }
            } else {
                id = e.record.id;
                if(assigned!='') {
                    $('#'+id).remove(); // remove from pending chats to accept
                    // hide from pending chat links
                    if($('#chatqueue').children().length==0) {
                       $('#pendingchats').hide();
                    }
                } else {
                    if(curstate=='closed') {
                        // if conversation is perhaps manually closed and not assigned to anyone, remove from pending list also
                        $('#'+id).remove(); // remove from pending chats to accept
                        // hide from pending chat links
                        if($('#chatqueue').children().length==0) {
                           $('#pendingchats').hide();
                        }
                    }
                }

                // Refresh active chat table for supervisors
                if($('#chatmonitor_main table.historychat').is(':visible')===true) {
                    console.log('call get chat monitor to refresh the list');
                    getChatMonitor();
                } else {
                    console.log('chatmonitor table.historychat no es visible no hago nada');
                }

            }
        }

        //if($('#chatmonitor_main >table.historychat').is(':visible')) {
            // refresh/reload chat monitor list XXX
        //}
    });
}

async function populateLastMessages() {
    console.log("populate last messages");
    var ids=[];
    $('.pendingchat-panel').each(async function() {
        ids.push($(this).attr('id'));
    });
    for(i=0;i<ids.length;i++) {
        var curid = ids[i];
        if($('#pendingmsg_'+curid).text().trim()=='') { // only get if message if empty
            if($('#'+curid).data('running')==1) {
                // ajax call already runnning
                console.log('ya estaba corriendo getLastMessage, lo salteo');
            } else {
                $('#'+curid).data('running',1)
                const body = await getLastMessageFromQueue(curid);
                $('#pendingmsg_'+curid).html(body);
                $('#'+curid).data('running',0)
            }
        }
    }
    console.log("fin initial last messages");
}

async function initialPendingChats() {
    console.log("initial pending chats");
    const pageResult = await pocketclient.collection('incomingqueue').getList( 1, 500, {
        filter: 'state = "open" && channel != "internal"',
    });
    console.log(pageResult);
    pageResult.items.forEach(item => {
        if(item.assignedto=="" || item.assignedto==parent.myextension) {
            alldata = JSON.stringify(item);
            addToChatQueue(item.id,alldata);
        }
    });
    //populateLastMessages();
    console.log("fin initial pending chats");
}

async function get_message_from_queue(msgid) {
    const msgResult = await pocketclient.collection('messages').getOne(msgid, { expand: "conversation"});
    return msgResult;
}

async function getHistoryMetadata(conversationid) {
    const msgResult = await pocketclient.collection('history').getOne(conversationid, { });
    return msgResult;
}


async function getLastMessageFromQueue(conversationId) {
    console.log("Inside getLastMessageFromQueue with conversationId: ", conversationId);
    try {
        const msgResult = await pocketclient.collection('messages').getList(1, 1, {
          sort: '-created',
          filter: `direction="inbound" && conversation="${conversationId}"`
        });
        console.log("Result of getLastMessageFromQueue: ", msgResult);
        if (msgResult?.items?.[0]?.body) {
            console.log("Last message from queue: ", msgResult.items[0].body);
            return msgResult.items[0].body;
        } else {
            console.warn("No messages found for conversation: ", conversationId);
            return "";
        }
    } catch (error) {
        console.error("Error in getLastMessageFromQueue: ", error);
        throw error;
    }
}

async function getConversationFromQueue(conversationid,chatid,icon,sender,tag,tohistory,channel) {
  // to history=1 is for history
  // to history=2 is for realtime monitor of active chats for supervisors

  console.log('get conversation from queue '+chatid+' for channel '+channel+'to history '+tohistory);
  if(tohistory==1) {
     // from history
     metaelement = $('#chathistory_main').get(0);
     metaprefix = 'history';
     showend='';
     updatestart='';
  } else if(tohistory==2) {
     // from monitor
     metaelement = $('#chatmonitor_main').get(0);
     metaprefix='monitor';
     showend='hidden';
     updatestart='';
  }

  metadataTable(conversationid,metaelement,metaprefix,showend,updatestart);

  const msgResult = await pocketclient.collection('messages').getFullList(500, {
    sort: 'created',
    filter: 'conversation = "'+conversationid+'"'
  });
  var dateStr='';

  msgResult.forEach((idx,idx2) => {
    item = msgResult[idx2];
    var msgid     = item.id;
    var avatar    = item.avatar;
    var number    = item.from;
    var finalfrom = item.name;
    var name      = item.name;
    var body      = item.body;
    var created   = item.created;
    var attach    = item.attachment;

    year        = created.substr(0,4);
    month       = parseInt(created.substr(5,2))-1;
    day         = created.substr(8,2);
    hour        = created.substr(11,2);
    minute      = created.substr(14,2);
    second      = created.substr(17,2);
    var utcDate = new Date(Date.UTC(year,month,day,hour,minute,second));
    dateStr = utcDate.getFullYear()+"-"+pad2(utcDate.getMonth())+"-"+pad2(utcDate.getDate())+" "+pad2(utcDate.getHours())+":"+pad2(utcDate.getMinutes())+":"+pad2(utcDate.getSeconds());

    if(item.direction=='inbound') { position = 'left'; } else if(item.direction=='outbound') { position = 'right'; } else { position = item.direction; }

    var files = [];
    if(attach.length>0) {
      files = [ msgid, attach ];
    }
    cont++;
    appendMessage(chatid, msgid, finalfrom, avatar, position, body, dateStr, icon, conversationid, tohistory, '', files, channel);
  });

  if(tohistory==1) {
    const msgHTML = `<div class="msg center-msg chathistoryback">${parent.lang.back}</div>`;
    $('#chathistory_main').get(0).insertAdjacentHTML("beforeend", msgHTML);
  }

  $('#chat_contact_name').text(sender);

  if(tohistory==1) {
    $('#conversationtag').data('conversationid',conversationid).val(tag);
    $('#conversationtag').data('nochange',1).trigger('change');
    $('.conversationtag').show();
    $('.msger-whisper').hide();
  }else if(tohistory==2) {
    $('.msger-input').hide();
    $('.msger-whisper').show();
    //$('.msger-send-btn').css('background-color','#d7b951');
    $('.msger-send-btn').css('background-color','#ffc');
    $('.msger-send-btn i').addClass('fa-sticky-note').removeClass('fa-paper-plane').css('color','#333');
    $('.msger-inputarea').show();
    $('.enachatinput').removeAttr('disabled');
    $('#msger-chat').scrollTop($('#msger-chat')[0].scrollHeight);
  }
  $('#historysearch').hide();

  doTrans();

}

async function initialOpenChannels() {
    console.log("initial open channels");
    const pageResult = await pocketclient.collection('incomingqueue').getList(1, 500, {
        filter: 'state = "openchannel"'
    });
    var ids      = [];
    var tos      = [];
    var senders  = [];
    var channels = [];
    var icons    = [];
    var dids     = [];
    pageResult.items.forEach(item => {
        ids.push(item.id);
        tos.push(item.did);
        senders.push(item.sender);
        channels.push(item.channel);
        icons.push(item.icon);
        dids.push(item.did);
        if($('#contact_'+item.channel+'_'+item.did).length==0) {
            createContact(item.did,item.sender,item.icon,item.id,"openchannel",item.channel,item.did,item.did);
            $('#contact_'+item.channel+'_'+item.did).insertBefore($('.extencontact').first());
        }
    })

    for(let i=0;i<ids.length;i++) {
        console.log("initial open channel "+i+" id "+ids[i]+" to "+tos[i]+" sender "+senders[i]+", channel "+channels[i]);
        const pipu = await pocketclient.collection('messages').getList(1, 500, {
          sort: '-created',
          filter: 'conversation = "'+ids[i]+'"'
        });
        msgResult = pipu.items;
        //console.log(msgResult);

        msgResult.reverse();
        console.log("initial open channel got messages from conversation "+ids[i]);

        msgResult.forEach((idx,idx2) => {
            item = msgResult[idx2]
            var msgid     = item.id;
            var idfrom    = item.from;
            var icon      = icons[i];
            var did       = dids[i];
            var avatar    = item.avatar;
            var from      = item.from;
            var to        = tos[i];
            var number    = to;
            var channel   = channels[i];
            var finalfrom = senders[i];
            var name      = item.name;
            if(name!='') finalfrom=name;
            var body      = item.body;
            var attach    = item.attachment;

            var created = item.created;
            year        = created.substr(0,4);
            month       = parseInt(created.substr(5,2))-1;
            day         = created.substr(8,2);
            hour        = created.substr(11,2);
            minute      = created.substr(14,2);
            second      = created.substr(17,2);
            var utcDate = new Date(Date.UTC(year,month,day,hour,minute,second));
            var dateStr = utcDate.getFullYear()+"-"+pad2(utcDate.getMonth())+"-"+pad2(utcDate.getDate())+" "+pad2(utcDate.getHours())+":"+pad2(utcDate.getMinutes())+":"+pad2(utcDate.getSeconds());

            position = 'left';
            if(item.direction=="groupagent") {
                position = 'right';
            }

            var files = [];
            if(attach.length>0) {
                files = [ msgid, attach ];
            }
            var nocounter=1;
            console.log("initial open channel appendmessage ",number,msgid,finalfrom,avatar,position,body,dateStr,icon,ids[i],0,'',files,channel,nocounter);
            appendMessage(number, msgid, finalfrom, avatar, position, body, dateStr, icon, ids[i], 0, 'openchannel', files, channel, nocounter, did);
            console.log("contact_"+to+" data-conversationid="+ids[i]);

        });
        console.log("initial open channel, end messages for conversation "+ids[i]);
    }

    //$('#contact_internal_'+tos[i]).attr('data-conversationid',ids[i]);
    console.log("zebra contact_internal_"+tos[i]+" set conversationid to "+ids[i]);

}

async function initialInternalChats() {

    console.log("initial internal chat");

    const pageResult = await pocketclient.collection('incomingqueue').getList(1, 500, {
        filter: 'channel = "internal" && (sender = "'+parent.myextension+'" || sender="internal_'+parent.myextension+'")'
    });
    var ids     = [];
    var tos     = [];
    var senders = [];
    pageResult.items.forEach(item => {
        ids.push(item.id);
        tos.push(item.assignedto);
        senders.push(item.sender);
    });

    console.log("initial internal chat total "+ids.length);
    for(let i=0;i<ids.length;i++) {
        console.log("initial internal chat "+i+" id "+ids[i]+" to "+tos[i]+" sender "+senders[i]);
        const pipu = await pocketclient.collection('messages').getList(1,500, {
          sort: '-created',
          filter: 'conversation = "'+ids[i]+'"'
        });
        msgResult = pipu.items;
        msgResult.reverse();

        console.log("initial internal got messages from conversation "+ids[i]);

        msgResult.forEach((idx,idx2) => {
            item = msgResult[idx2];
            console.log(item);
            var msgid     = item.id;
            var idfrom    = item.from;
            var avatar    = item.avatar;
            var from      = item.from;
            var to        = tos[i];
            var number    = to;
            var channel   = 'internal';
            var finalfrom = senders[i];
            var name      = item.name;
            if(name!='') finalfrom=name;
            var body      = item.body;
            var attach    = item.attachment;

            var created = item.created;
            year        = created.substr(0,4);
            month       = parseInt(created.substr(5,2))-1;
            day         = created.substr(8,2);
            hour        = created.substr(11,2);
            minute      = created.substr(14,2);
            second      = created.substr(17,2);
            var utcDate = new Date(Date.UTC(year,month,day,hour,minute,second));
            var dateStr = utcDate.getFullYear()+"-"+pad2(utcDate.getMonth())+"-"+pad2(utcDate.getDate())+" "+pad2(utcDate.getHours())+":"+pad2(utcDate.getMinutes())+":"+pad2(utcDate.getSeconds());

            position = 'left';
            if(item.direction=="outbound") {
                position = 'right';
                //number = to;
            } else {
                //number = from;
            }
            console.log("number "+number);

            var files = [];
            if(attach.length>0) {
                files = [ msgid, attach ];
            }

            /*
            if(avatar=='') {  
                const separator = avatar_url.includes('?') ? '&' : '?';
                avatar = avatar_url+separator+'seed='+number; 
            }
            */

            var nocounter=1;
            console.log("initial internal appendmessage, number="+number+",msgid="+msgid+",finalfrom="+finalfrom+",avatar="+avatar+",position="+position+",body="+body+",dateStr="+dateStr+",conversationid="+ids[i]+",tohistoryr=0,files="+files+",channel="+channel+",nocounter="+nocounter,+"did=internal");
            appendMessage(number, msgid, finalfrom, avatar, position, body, dateStr, undefined, ids[i], 0, '', files, channel, nocounter,'internal');
            console.log("contact_"+to+" data-conversationid="+ids[i]);

        });
        console.log("initial internal chat, end messages for conversation "+ids[i]);
    }

    $('#contact_internal_'+tos[i]).attr('data-conversationid',ids[i]);
    console.log("zebra contact_internal_"+tos[i]+" set conversationid to "+ids[i]);

    const pageResult2 = await pocketclient.collection('incomingqueue').getList(1, 500, {
        filter: 'channel = "internal" && assignedto = "internal_'+parent.myextension+'"',
    });

    pageResult2.items.forEach(item => {
        $('#contact_'+item['sender']).attr('data-conversationid2',item['id']);
    });

    console.log("fin initial internal chat");
}


async function initialAssignedChats() {

    console.log("initial assigned chat");

    const pageResult = await pocketclient.collection('incomingqueue').getList(1, 50, {
        filter: 'state = "assigned" && channel != "internal" && assignedto = "'+parent.myextension+'"',
    });
    var ids     = [];
    var senders = [];
    var chatids = [];
    var icons   = [];
    var channels= [];
    var avatars = [];
    var numbers = [];
    var tags    = [];
    var dids    = [];
    pageResult.items.forEach(item => {
          ids.push(item.id);
          chatids.push(item.chatid);
          senders.push(item.sender);
          channels.push(item.channel);
          icons.push(item.icon);
          avatars.push(item.avatar);
          numbers.push(item.phonenumber);
          tags.push(item.tag);
          dids.push(item.did);
    });

    console.log("initial assigned chat total "+ids.length);
    for(let i=0;i<ids.length;i++) {
        console.log("initial assigned chat "+i);
        const msgResult = await pocketclient.collection('messages').getFullList(200, {
          sort: 'created',
          filter: 'conversation = "'+ids[i]+'"'
        });

        console.log("got messages from conversation "+ids[i]);

        msgResult.forEach((idx,idx2) => {
            item = msgResult[idx2];
            var msgid     = item.id;
            var idfrom    = senders[i];
            var icon      = icons[i];
            var avatar    = item.avatar;
            var number    = numbers[i];
            var channel   = channels[i];
            console.log("i "+i);
            console.log("number "+number);
            var finalfrom = senders[i];
            var name = item.name;
            if(name!='') finalfrom=name;
            var body      = item.body;
            var attach    = item.attachment;

            var created = item.created;
            year        = created.substr(0,4);
            month       = parseInt(created.substr(5,2))-1;
            day         = created.substr(8,2);
            hour        = created.substr(11,2);
            minute      = created.substr(14,2);
            second      = created.substr(17,2);
            var utcDate = new Date(Date.UTC(year,month,day,hour,minute,second));
            var dateStr = utcDate.getFullYear()+"-"+pad2(utcDate.getMonth())+"-"+pad2(utcDate.getDate())+" "+pad2(utcDate.getHours())+":"+pad2(utcDate.getMinutes())+":"+pad2(utcDate.getSeconds());

            if(item.direction=='inbound') {
                position = 'left';
                avatar = avatars[i];
            } else if(item.direction=='outbound'){
                position = 'right';
            } else if(item.direction=='broadcast') {
                position = item.direction;
                avatar = item.avatar;
            } else if(item.direction=='autoreply'){
                position = item.direction;
                avatar = 'https://avatars.dicebear.com/api/bottts/your-asdf4.svg';
            } else {
                position = item.direction;
            }

            var files = [];
            if(attach.length>0) {
                files = [ msgid, attach ];
            }

            var nocounter=1;
            appendMessage(number, msgid, finalfrom, avatar, position, body, dateStr, icon, ids[i], 0, tags[i], files, channel, nocounter, dids[i]);

        });
        console.log("initial assigned chat, end messages for conversation "+ids[i]);
    }
    console.log("fin initial assigned chat");

    doTrans();
}

async function getChatMonitor() {

    if(chatDisabled==1) { return }

    if(!parent.permisos.includes('supervisor') && !parent.permisos.includes('all')) {
        return;
    }

    if($('.chatmonitor').attr('disabled')=='disabled') { return; }
    $('.chatmonitor').attr('disabled','disabled');

    $('#historysearch').hide();

    console.log('get chat monitor');

    $('.msger-header').css('background','').css('background-color','#eee');

    $('#conversationtag').val([]);
    $('#conversationtag').data('nochange',1).trigger('change');
    $('.msger-send-btn i').removeClass('fa-sticky-note').addClass('fa-paper-plane').css('color','#FFF');
    $('.msger-send-btn').css('background-color','#ccc'); // to grey
    $('.conversationtag').hide();
    $('.contactchat').hide();
    $('.msger-inputarea').hide();
    $('#header_chat_icon').removeClass('fa-comment-alt').removeClass('fa-history').removeClass('fa-inbox').addClass('fa-desktop');
    $('#chat_contact_name').text(parent.lang['chatmonitor']);
    $('#chathistory_main').hide();
    $('#voicemail_main').hide();
    $('#omniplayer').hide();
    $('.chattransfer').hide();

    $('#chatmonitor_main').html('<div class="horizontal-bar-wrap"><div class="bar1 bar"></div></div>').show();

    var filter = '(state = "assigned" || state = "open" || state = "bot") && channel != "internal" && context = "'+panelcontext+'"';

    perPage = 100;

    const pageResult = await pocketclient.collection('incomingqueue').getList( 1, perPage, {
        filter: filter,
        sort: '-created'
    });
    //console.log(pageResult);
    var content='<table class="table table-striped historychat">';
    content+=`<thead><tr><th></th><th>${parent.lang.contact}</th><th>${parent.lang.datestart}</th><th>${parent.lang.lastupdate}</th><th>${parent.lang.agent}</th></tr></thead>`;
    content+='<tbody>';
    var currentPage = pageResult.page;
    var totalPages  = pageResult.totalPages;
    var totalItems  = pageResult.totalItems;

    pageResult.items.forEach(item => {
        var started = item.created.slice(0,-4);
        var ended = item.updated.slice(0,-4);
        var startedprint = gmtdate(started);
        var endedprint   = gmtdate(ended);
        content += `<tr class="trchatmonitor" data-tag="${item.tag}" data-channel="${item.channel}" data-sender="${item.sender}" data-chatid="${item.chatid}" data-icon="${item.icon}" id="trhistory_${item.id}">
                       <td><img class="history-img" src='${item.icon}'></td><td>${item.sender}</td><td>${startedprint}</td><td>${endedprint}</td><td>${item.assignedto}</td>
                   </tr>`;
    });
    content+='</tbody>';
    content+='<tfoot>';
    content+='<tr><th colspan=5><nav class="pagination-container"><div id="pagination-numbers"></div></nav></th>';
    content+='</tfoot>';
    content+='</table>';

    if(totalItems==0) {
        content='<table class="table table-striped historychat"></table><div style="text-align:center;"><h3>'+parent.lang['no_results']+'</h3></div>';
    }

    $('#chatmonitor_main').html(content);
    $('.chatpart').removeClass('disabled');
    $('#history_close').css('display','inline-block');
    $('#historysearch').hide();
    $('#chat_menu').hide();
    $('#msger-chat').removeClass('msger-chat').removeClass('msger-history').removeClass('msger-voicemail').addClass('msger-monitor');
    $('#chat_transfer_conversation').hide();
    $('#chat_close_conversation').hide();
    $('#chat_audiocall').hide();
    $('#chat_clear').hide();


    if(totalPages>1) {

        appendPageNumber('first');
        appendPageNumber('previous');

        for (let i = 1; i <= totalPages; i++) {
           appendPageNumber(i);
        }
        appendPageNumber('next');
        appendPageNumber('last');

        setCurrentPage(history_current_page,totalPages,0);

        document.querySelectorAll(".pagination-number").forEach((button) => {
          //const pageIndex = Number(button.getAttribute("page-index"));
          const pageIndex = button.getAttribute("page-index");

          if (pageIndex) {
            button.addEventListener("click", () => {
              setCurrentPage(pageIndex,totalPages);
            });
          }
        });

    }
    $('.chatmonitor').removeAttr('disabled');
}

// function that prints between one to five start emojis based on input
function printStars(rating) {
  if(rating==0) { return '';
  } else {
    var stars = '';
    for (var i = 0; i < 5; i++) {
      if (i < rating) {
        stars += '⭐';
      }
    }
    return stars;
  }
}

async function getChatHistory() {

    if(chatDisabled==1) { return }

    console.log('get chat history '+$('#historysearch').val());

    if($('.chathistory').attr('disabled')=='disabled') { return; }
    $('.chathistory').attr('disabled','disabled');

    $('#historysearch').show();
    let currentsort = localStorage.getItem("historysort");
    if(currentsort===null) {
        currentsort='-created';
        localStorage.setItem("historysort", currentsort);
    }
    let sortby      = currentsort;
    let sorticon    = 'fa-sort-up';

    if(sortby.charAt(0)=='-') {
        sortby = sortby.slice(1);
        sorticon    = 'fa-sort-down';
    }

    $('.msger-header').css('background','').css('background-color','#eee');
    $('.conversationtag').prop("selectedIndex", 0);
    $('.conversationtag').hide();  // select2 refresh
    $('.contactchat').hide();
    $('.chattransfer').hide();
    $('.msger-inputarea').hide();
    $('#header_chat_icon').removeClass('fa-comment-alt').removeClass('fa-desktop').removeClass('fa-inbox').addClass('fa-history');
    $('#chat_contact_name').text(parent.lang['menu_chat_history']);
    $('#chatmonitor_main').hide();
    $('#omniplayer').hide();
    $('#voicemail_main').hide();
    $('#chathistory_main').html('<div class="horizontal-bar-wrap"><div class="bar1 bar"></div></div>').show();

//    await new Promise(r => setTimeout(r, 2000));

    var filter = 'channel != "internal" && context = "'+panelcontext+'" && (state = "closed" && assignedto="'+parent.myextension+'")';
    if(history_type=='single') {
        var filter = 'channel != "internal" && (state = "closed" && chatid~"'+selectedContact+'")';
    }

    if($('#historysearch').val()!='') {
        var v = $('#historysearch').val();
        filter += '&&(body~"'+v+'"||csat_feedback~"'+v+'"||sender~"'+v+'"||tag~"'+v+'")';
    }

    // populate empty row to calculate height and thus number of lines
    var dummy_content='<table class="table table-striped historychat">';
    dummy_content+= '<tr class="trchathistory"><td></td><td>some sender</td><td>0000-00-00 00:00:00</td><td>10m</td><td>0000</td><td>some tag</td></tr>';
    dummy_content+='</table>';
    $('#chathistory_main').html(dummy_content);

    var window_height = $('#msger-chat').height()
    var line_height = parseInt($('tr.trchathistory').css('height'));
    $('#chathistory_main').html('');
    var lines = parseInt(window_height / line_height) - 3;


    if($('#historysearch').val()!='') {
        perPage = 500;
    } else {
        perPage = lines; //12
    }
    const pageResult = await pocketclient.collection('history').getList( history_current_page, perPage, {
        filter: filter,
        sort: currentsort
    });

    console.log(pageResult);

    var content='<table class="table table-striped historychat">';
    content+=`<thead><tr><th></th><th class='sortsender'>${parent.lang.contact} ${sortby=='sender'?'<i class="sorti fas '+sorticon+'"></i>':'<i class="sorti disabled fas fa-sort"></i>'}</th><th class='sortcreated'>${parent.lang.datestart} ${sortby=='created'?'<i class="sorti fas '+sorticon+'"></i>':'<i class="sorti disabled fas fa-sort"></i>'}</th><th class='sortduration'>${parent.lang.Duration} ${sortby=='duration'?'<i class="sorti fas '+sorticon+'"></i>':'<i class="sorti disabled fas fa-sort"></i>'}</th><th class='sortassignedto'>${parent.lang.agent} ${sortby=='assignedto'?'<i class="sorti fas '+sorticon+'"></i>':'<i class="sorti disabled fas fa-sort"></i>'}</th> <th class='sorttag'>${parent.lang.tag} ${sortby=='tag'?'<i class="sorti fas '+sorticon+'"></i>':'<i class="sorti disabled fas fa-sort"></i>'}</th> <th class='sortcsat_rating'>${parent.lang.csat_rating} ${sortby=='csat_rating'?'<i class="sorti fas '+sorticon+'"></i>':'<i class="sorti disabled fas fa-sort"></i>'}</th> </tr></thead>`;
    content+='<tbody>';
    var currentPage = pageResult.page;
    var totalPages  = pageResult.totalPages;
    pageResult.items.forEach(item => {
    var started = item.created.slice(0,-4);
    var ended = item.finished.slice(0);
    var startedprint = gmtdate(started);
    var endedprint   = gmtdate(ended);
    var minutes      = Math.round(item.duration/60 *10)/10;

    if(minutes<60) {
        durationprint = minutes + "m";
    } else {
        hours = Math.round(minutes / 60 * 10 ) / 10;
        durationprint  = hours +'h';
    }
    csat_print = printStars(item.csat_rating);
    content += `<tr class="trchathistory" data-tag="${item.tag}" data-channel="${item.channel}" data-sender="${item.sender}" data-chatid="${item.chatid}" data-icon="${item.icon}" id="trhistory_${item.id}">
                <td><img class="history-img" src='${item.icon}'></td><td>${item.sender}</td><td>${startedprint}</td><td>${durationprint}</td><td>${item.assignedto}</td><td>${item.tag}<span class='hidden'>${item.body}</span></td><td>${csat_print}</td></tr>`;
    });
    content+='</tbody>';
    content+='<tfoot>';
    content+='<tr><th colspan=8><nav class="pagination-container"><div id="pagination-numbers"></div></nav></th>';
    content+='</tfoot>';
    content+='</table>';
    $('#chathistory_main').html(content);
    $('.chatpart').removeClass('disabled');
    $('#history_close').css('display','inline-block');
    $('#chat_menu').hide();
    $('#msger-chat').removeClass('msger-chat').addClass('msger-history').removeClass('msger-monitor').removeClass('msger-voicemail');
    $('#chat_transfer_conversation').hide();
    $('#chat_close_conversation').hide();
    $('#chat_audiocall').hide();
    $('#chat_clear').hide();

    if(totalPages>0) {
        appendPageNumber('first');
        appendPageNumber('previous');

        for (let i = 1; i <= totalPages; i++) {
           appendPageNumber(i);
        }
        appendPageNumber('next');
        appendPageNumber('last');

        setCurrentPage(history_current_page,totalPages,0);

        document.querySelectorAll(".pagination-number").forEach((button) => {
          const pageIndex = button.getAttribute("page-index");

          if (pageIndex) {
            button.addEventListener("click", () => {
              setCurrentPage(pageIndex,totalPages);
            });
          }
        });
    }
    $('.chathistory').removeAttr('disabled');
}

function gmtdate(datestring) {
    year        = datestring.substr(0,4);
    month       = parseInt(datestring.substr(5,2));
    day         = datestring.substr(8,2);
    hour        = datestring.substr(11,2);
    minute      = datestring.substr(14,2);
    second      = datestring.substr(17,2);
    var utcDate = new Date(Date.UTC(year,month,day,hour,minute,second));
    var dateStr = utcDate.getFullYear()+"-"+pad2(utcDate.getMonth())+"-"+pad2(utcDate.getDate())+" "+pad2(utcDate.getHours())+":"+pad2(utcDate.getMinutes())+":"+pad2(utcDate.getSeconds());
    return dateStr;
}

function setDropzone() {
    myDrop = new Dropzone('.msger-input',{
        url: "/realtime/api/collections/messages/records",
        paramName: 'attachment',
        clickable: '.btnattach',
        previewsContainer: '.msger-chat',
        maxFilesize: 50,
        autoProcessQueue: false,
        maxFiles: 5,
        addRemoveLinks: true,
        dictRemoveFile: parent.lang.removefile,
        headers:{"Authorization":'User '+pocketclient.authStore.baseToken},
        previewTemplate: '<div class="dz-preview msg-bubble dz-file-preview"> <div class="dz-details"> <div class="dz-filename"><span data-dz-name></span></div> <div class="dz-size" data-dz-size></div> <img data-dz-thumbnail /> </div> <div class="dz-progress"><span class="dz-upload" data-dz-uploadprogress></span></div> <div class="dz-success-mark"><span>✔</span></div> <div class="dz-error-mark"><span>✘</span></div> <div class="dz-error-message"><span data-dz-errormessage></span></div> </div>',
        accept: function(file,done) {
            if($('.msger-input').attr('disabled')=='disabled') {
                done(parent.lang.disabled);
            } else {
                done();
                if(file.type=="image/webp") {
                    $('#chatinputbox').submit();
                }
            }
        }
    });

    $('.msger-chat').addClass('dropzone');

    myDrop.on("addedfile", file => {
        $('.attach-dropup').trigger('blur');
        $('#msger-chat').scrollTop($('#msger-chat')[0].scrollHeight);
        $('.msger-send-btn').css('background-color','#00c441');
        let howmany = myDrop.getQueuedFiles().length;
        howmany++;
        if(howmany>0) {
            console.log("added file "+howmany);
            //if(file.type=="image/webp") {
            //    setTimeout(function() {$('#chatinputbox').submit();},500);
           // }
            $('.attachbadge').text(howmany);
        } else {
            $('.attachbadge').text('');
        }
    });

    myDrop.on("removedfile", file => {
        if(myDrop.getQueuedFiles().length==0) {
            $('.msger-send-btn').css('background-color','#ccc');
        }
        let howmany = myDrop.getQueuedFiles().length;
        if(howmany>0) {
            $('.attachbadge').text(howmany);
        } else {
            $('.attachbadge').text('');
        }

    });

    $('.msger-input').on('dragenter', function() {
        console.log(typeof($(this).attr('disabled')));
        if(typeof($(this).attr('disabled'))=='undefined') {
            $(this).css('outline','2px dashed black').attr('placeholder',parent.lang.dropfileshere);
        }
    });

    $('.msger-input').on('dragleave', function() {
        if(typeof($(this).attr('disabled'))=='undefined') {
            $(this).css('outline','none').attr('placeholder',parent.lang.enteryourmessage);
        }
    });
    $('.msger-input').on('drop', function() {
        if(typeof($(this).attr('disabled'))=='undefined') {
            $(this).css('outline','none').attr('placeholder',parent.lang.enteryourmessage);
        }
    });

}

async function getProviders() {
    return provider_list;
}

function transfer_template(tpl) {
    if(tpl.title=='') {
        ret = `<i class='fas fa-user'></i> <span>${tpl.text}</span>`;
    } else {
        ret = `<i class='${tpl.title}'></i> <span>${tpl.text}</span>`;
    }
    return $(ret);
}

document.addEventListener('DOMContentLoaded', (event) => {

    $select = $('#conversationtag').select2({ minimumResultsForSearch: -1, placeholder: parent.lang['Tag'] });
    $select.data('select2').$container.addClass('conversationtag').hide();

    if(parent.plugins['phonepro'].hasVoicemail()==1) {
        $('.showmwi').show();
    } else {
        $('.showmwi').hide();
    }

    if(parent.permisos.includes('supervisor') || parent.permisos.includes('all')) {
        $('.chatmonitor').show();
    } else {
        $('.chatmonitor').remove();
    }
/*
    fetch('../menu/api.php?action=missedcalls').then((response)=>response.json()).then((voicemailData)=> {
        for (const [filename, message] of Object.entries(voicemailData)) {
            const path = filename;
            const parts = path.split("/");
            const folder = parts[parts.length - 2];

            console.log(`Message File: ${filename}`);
            console.log(`Folder: ${folder}`);
            console.log(`Caller ID: ${message.callerid}`);
            console.log(`Date: ${message.origdate}`);
            console.log(`Time: ${message.origtime}`);
            console.log(`Duration: ${message.duration}`);
            console.log("----");

const date = new Date(message.origtime * 1000);
//const options = { year: 'numeric', month: '2-digit', day: '2-digit', hour: '2-digit', minute: '2-digit', second: '2-digit', hour12: false, hourCycle: 'h24',  timeZone: Intl.DateTimeFormat().resolvedOptions().timeZone };
const options = { year: 'numeric', month: '2-digit', day: '2-digit', hour: '2-digit', minute: '2-digit', second: '2-digit', timeZone: Intl.DateTimeFormat().resolvedOptions().timeZone, hour12: false, hourCycle: 'h24' };

const localDateString = date.toLocaleString('en-US', options).replace(/(\d+)\/(\d+)\/(\d+)/, '$3-$1-$2');;

            $('#panel_'+folder).append(`${localDateString} - ${message.callerid} - Duration ${message.duration}<br/>`);
        }
    })
*/

    parent.sonido['blip'].play().then(function() {}).catch(function() {  parent.alertify.confirm(parent.lang['Click to enable sounds']);} );

    (function fetchData() {
        fetch('../menu/api.php?action=listProviders').then((response)=>response.json()).then((data)=> {
            provider_list = data;
            data.map(function(el,id) {
                trimdid = el.did.toString().replace(/[^A-Za-z0-9_]/g, "");
                provider_capabilities[el.channel+'_'+trimdid]=el.capabilities;
                provider_ptt[el.channel+'_'+trimdid]=el.enable_audio;
                provider_audiocall[el.channel+'_'+trimdid]=el.enable_voice;
                provider_icon[el.channel+'_'+trimdid]=el.icon;
                provider_crm[el.channel+'_'+trimdid]=el.chatbroker_crm;
                provider_tags[el.channel+'_'+trimdid]=el.tags;
                provider_name[el.channel+'_'+trimdid]=el.description;
            });
        }).catch(error => { console.error("Could not get providers list"); setTimeout(fetchData,2000);})
    })();

    fetch('../menu/api.php?action=listGroups').then((response)=>response.json()).then((data)=> {

        service_groups = data;

        options = $("#chattransferto option").remove()

        og = $('<optgroup/>').attr('label', parent.lang['Service Groups']).attr('title','fas fa-users');

        og.append($(`<option value='ALL' title='fas fa-users'>${parent.lang['All Extensions']}</option>`));

        for (const [key, myvalue] of Object.entries(service_groups)) {
            if(key!='All Extensions') {
                og.append($(`<option value='[${key}]' title='fas fa-users'>${key}</option>`));
            }
        }
        $('#chattransferto').append(og);

        og = $('<optgroup/>').attr('label', parent.lang['Agents']).attr('title','fas fa-user');
        og.append(options);
        $('#chattransferto').append(og);

        fetch('../menu/api.php?action=listBots').then((response)=>response.json()).then((data)=> {
            og = $('<optgroup/>').attr('label', parent.lang['Bots']).attr('title','fas fa-robot');
            for (const [key, myvalue] of Object.entries(data)) {
                og.append($(`<option value='{${key}}' title='fas fa-robot'>${myvalue}</option>`));
            }
            $('#chattransferto').append(og);
        });

        $select = $('#chattransferto').select2({templateResult: transfer_template, placeholder: parent.lang.assignto, allowClear: true});
        $select.data('select2').$container.addClass('chattransfer').hide();
        $('#chattransferto').val(null);


        $('#chattransferto').on('select2:unselecting',function(e) { $('#chat_transfer_conversation').css('background-color','#FFF'); });
        $('#chattransferto').on('select2:select',function(e) {
            var data = e.params.data;
            console.log(data);
            if(data=='') {
                $('#chat_transfer_conversation').css('background-color','#FFF');
            } else {
                $('#chat_transfer_conversation').css('background-color','#3E3');
            }
        });


    });

    $('#historysearch').on('search',function() {
        if($(this).val()=='') {
            getChatHistory().then(() => filterHistory());
        }
    });

    $('.btnmicrophone').on('click',function() {
        // start web recorder
        startstopRecording();
    });

    $('#recordTrash').on('click',function() {
        trashRecording();
    });

    $('.attachfile').on('click',function() {
        // restrict myDrop acceptedFiles
        var accepttype = []
        accepttype.push(
           'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
           'application/msword',
           'application/pdf',
           'application/vnd.ms-excel',
           'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
           'application/zip',
           'text/plain'
        );

        myDrop.options.acceptedFiles = accepttype.join(',');
        $('.dz-hidden-input').attr('accept',accepttype.join(','));
    });

    $('.attachimage').on('click',function() {
        // restrict myDrop acceptedFiles
        var accepttype = []
        accepttype.push(
           'image/jpeg','image/png','image/gif','video/*'
        );
        myDrop.options.acceptedFiles = accepttype.join(',');
        $('.dz-hidden-input').attr('accept',accepttype.join(','));
    });

    $('.attachsticker').on('click',function() {
        // restrict myDrop acceptedFiles
        var accepttype = []
        accepttype.push(
           'image/webp'
        );
        myDrop.options.acceptedFiles = accepttype.join(',');
        $('.dz-hidden-input').attr('accept',accepttype.join(','));
    });

    $(document).on('click','table.historychat thead tr th', function() {
        // click on table th history for sorting
        let sortby = 'created';
        if(typeof($(this).attr('class'))!='undefined') {
            sortby = $(this).attr('class').substr(4);
        }
        storedsort = localStorage.getItem("historysort");
        if(storedsort === null) {
            sortby='created';
            storedsort = sortby;
        }

        if (sortby=='finished') {
            sortby = '(created-finished)';
        }
        let finalsort;
        if(storedsort==sortby || storedsort=="-"+sortby) {
            if(storedsort.indexOf("-")>=0) {
                finalsort = sortby;
            } else {
                finalsort = "-"+sortby;
            }
        } else {
            finalsort = sortby;
        }
        if(finalsort=='-' || finalsort=='') { finalsort='-created'; }
        if(sortby.charAt(0)=='-') {
            sortby = sortby.slice(1);
        }
        localStorage.setItem("historysort", finalsort);

        getChatHistory().then(() => filterHistory());
    });

    $("#chat_menu").contextMenu({
        menuSelector: "#contextMenu",
        menuSelected: function (invokedOn, selectedMenu) {
            var msg = "You selected the menu item " + selectedMenu.text();
            console.log(msg);
        }
    });

    $("#call_spy").contextMenu({
        menuSelector: "#contextMenuSpy",
        menuSelected: function (invokedOn, selectedMenu) {
            destino = selectedContact.split("_")[1];
            if(selectedMenu.attr('id')=='action_call_spy') {
                console.log("spy on "+parent.extenpos[destino]);
                parent.spy(parent.extenpos[destino]);
            } else if(selectedMenu.attr('id')=='action_call_whisper') {
                console.log("whisper on "+parent.extenpos[destino]);
                parent.whisper(parent.extenpos[destino]);
            } else if(selectedMenu.attr('id')=='action_call_barge') {
                console.log("barge on "+parent.extenpos[destino]);
                parent.barge(parent.extenpos[destino]);
            }
            var msg = "You selected the menu item " + selectedMenu.text();
            console.log(msg);
        }
    });

    $('#lbl_enteryourmessage').on('input',function() {
        if($(this).val()!='') {
            $('.msger-send-btn').css('background-color','#00c441');
        } else {
            if(myDrop.getQueuedFiles().length==0) {
                $('.msger-send-btn').css('background-color','#ccc');
            }
        }
    });

    if(parent.context=='' || parent.context=='general') {
        pocketuser = parent.myextension+'@asternic.noemail';
    } else {
        pocketuser = parent.myextension+'@'+parent.context.toLowerCase()+'.noemail';
    }
    pocketpass = parent.window.name.substring(parent.window.name.indexOf('pass=')).substr(5);
    if(pocketpass.length < 8) {
        pocketpass = pocketpass.padEnd(8, 'X');
    }

    pocketclient.collection('users').authWithPassword(pocketuser, pocketpass).then((resu)=>{
        chatDisabled=0;
        //initialPendingChats().then(()=>populateLastMessages()).then(()=>initialAssignedChats()).then(()=>initialInternalChats()).then(()=>chatRealtime());
        initialPendingChats().then(()=>populateLastMessages()).then(()=>initialAssignedChats()).then(()=>initialInternalChats()).then(()=>chatRealtime()).then(()=>initialOpenChannels());
        setDropzone();

        fetch('../menu/api.php?action=checkauth').then((response)=>response.json()).then((xdata)=> {
            if(xdata.authenticated===false) {
                $('#chat_'+selectedContact).html('');
                chatDisabled=1;
                $('#chat_contact_name').text('API Error');
                setFooterText(xdata.reason);
                $('#header_chat_icon').removeClass().addClass('fas fa-exclamation-triangle');
                $('.chathistory').addClass('disabled');
                $('.chatmonitor').addClass('disabled');
            }
        });

    }).catch(error => {
        // Chat Broker not running
        chatDisabled=1;
        setFooterText(parent.lang.chatbrokernotrunning);
        $('#chat_contact_name').text(parent.lang.chatbrokernotrunning);
        $('#header_chat_icon').removeClass().addClass('fas fa-exclamation-triangle');
        $('.chathistory').addClass('disabled');
        $('.chatmonitor').addClass('disabled');
    });

    $('.enachatinput').attr('disabled','disabled');
    populateDevices();
    render();
    var ringend;
    var mwidisabled=false;

    $('#menu_view_contact').on('click',function() {
        window.parent.editrecord($('#menu_view_contact').attr('data-contactid'),selectedContact);
    });

    $('#menu_add_contact').on('click',function() {
        window.parent.$('.image-editor').cropit('imageSrc','./images/user.png');
        //window.parent.$('.cropit-image-preview').css('background-image','url()');
        window.parent.$('#contactaction').val('insert');
        fetch("../../../../contacts.php?action=exists&number="+selectedContact)
        .then((response)=>response.json())
        .then((data) => {
            if(data.id>0) {
                 window.parent.editrecord(data.id);
            } else {

                // iterate array of objects
                for (var i = 0; i < provider_list.length; i++) {
                    if($('#contact_'+selectedContact).data('channel')==provider_list[i].channel) {
                        use_number_from = provider_list[i].use_number_from;
                    }
                }
                console.log("use number from "+use_number_from);


                firstname=$('#chat_contact_name').text().split(" ")[0];
                lastname=$('#chat_contact_name').text().split(" ")[1];
                window.parent.$('#firstname').val(firstname);
                window.parent.$('#lastname').val(lastname);
                window.parent.$('#channelid').val(selectedContact);
                if(use_number_from == 'whatsapp' || use_number_from == 'sms') {
                    window.parent.$('#phone').val($('#contact_'+selectedContact).data('phonenumber'));
                    window.parent.$("select[name='phonetype[]']").val(use_number_from);
                } else if(use_number_from != '') {
                    // instagram and telegram use a random number id
                    window.parent.$('#'+use_number_from).val(selectedContact);
                    window.parent.$('#firstname').val('');
                    window.parent.$('#lastname').val('');
                }
                window.parent.$(':input','#contactForm')
                 .not(':button, :submit, :reset, :hidden')
                 .val('')
                 .removeAttr('checked', false)
                 .removeAttr('selected', false);
                $('.morephones').html('');
                window.parent.$('#sendmessageselector').hide();
                window.parent.$('#notesubmit').hide();
                window.parent.$('#buttondelete').hide();
                window.parent.$('#contactForm').modal();

            }
        });

    });

    $('#history_close').on('click',function() {
        if($('#chathistory_main').is(':visible')) {
            if($('#chathistory_main table.historychat').is(':visible')) {
                $('#chathistory_main').html('').hide();
                $('#msger-chat').removeClass('msger-history').addClass('msger-chat').removeClass('msger-monitor').removeClass('msger-voicemail');
                $('#header_chat_icon').removeClass('fa-history').addClass('fa-comment-alt').removeClass('fa-inbox').removeClass('fa-desktop');
                $('#history_close').hide();
                $('.msger-inputarea').show();
                $('.chatpart').addClass('disabled');
                $('#chat_contact_name').text('');
                $('#historysearch').val('').hide();
                if($('#contact_'+selectedContact).length>0) { $('#contact_'+selectedContact).trigger('click'); }
            } else {
                getChatHistory().then(() => filterHistory());
            }
        } else if($('#chatmonitor_main').is(':visible')){
            if($('#chatmonitor_main table.historychat').is(':visible')) {
                $('#chatmonitor_main').html('').hide();
                $('#msger-chat').removeClass('msger-history').addClass('msger-chat').removeClass('msger-monitor').removeClass('msger-voicemail');
                $('#header_chat_icon').removeClass('fa-history').addClass('fa-comment-alt').removeClass('fa-inbox').removeClass('fa-desktop');
                $('#history_close').hide();
                $('.msger-inputarea').show();
                $('.chatpart').addClass('disabled');
                $('#chat_contact_name').text('');
                $('#chatmonitor_main').data('currentconversation','');

            } else {

                getChatMonitor();
                $('#chatmonitor_main').data('currentconversation','');
            }
        }
    });

    $('#menu_chat_history').on('click',function() {
        if($('#chat_'+selectedContact).is(':visible')==true) {
            $('.msger-inputarea').hide();
            $('#chat_'+selectedContact).hide();
            $('#chathistory_main').html('').show();
            $('#chatmonitor_main').hide();
            $('#menu_chat_history').html(parent.lang.currentchat);
            $('#msger-chat').removeClass('msger-chat').addClass('msger-history').removeClass('msger-monitor').removeClass('msger-voicemail');
            $('#chat_transfer_conversation').hide();
            $('#chat_close_conversation').hide();
            history_type='single';
            getChatHistory().then(() => filterHistory());
        } else {
            $('.msger-inputarea').show();
            $('#header_chat_icon').removeClass('fa-history').addClass('fa-comment-alt').removeClass('fa-inbox').removeClass('fa-desktop');
            $('#history_close').hide();
            $('#chat_'+selectedContact).show();
            $('#chathistory_main').hide();
            $('#chatmonitor_main').hide();
            $('#voicemail_main').hide();
            $('#menu_chat_history').html(parent.lang['menu_chat_history']);
            $('#msger-chat').removeClass('msger-history').addClass('msger-chat').removeClass('msger-monitor').removeClass('msger-voicemail');
            $('#chat_transfer_conversation').css('display','inline-block');
            $('#chat_close_conversation').css('display','inline-block');
        }
    });

    $('#conversationtag').on('change',function(ev) {
        var nochange = $(this).data('nochange');
        if(nochange==1) {  $(this).data('nochange',0); return }
        var id = $(this).data('conversationid');
        var val = $(this).val();
        updateConversationTag(id,val);
    });

    $('#ringtone').on('change',function() {
        var rt = $(this).val();
        console.log(rt);
        localStorage.setItem("ringtone", rt);
        $('#bell').attr('src','sounds/'+$(this).val()+'.mp3');
        clearTimeout(ringend);
        el = document.getElementById('bell');
        el.setSinkId(getRingerDevice());
        el.play().then(
          function() {
            ringend = setTimeout(
              function() { el.pause(); }, 2000
            );
        }).catch(
          function() {
            console.log('error playing audio');
            el.pause();
          }
        );
    });

    // Handle output change (speaker)
    $('#microphoneSrc').on('change',function() {
        console.log("Change Microphone ("+ this.value +")");
        localStorage.setItem("MicDevice", this.value);
        userAgentOptions.sessionDescriptionHandlerFactoryOptions.constraints.audio.deviceId = { exact: this.value }
        displayMeter();
    });

    $('#playbackSrc').on('change',function() {
        localStorage.setItem("SpeakerDevice", this.value)
    });

    $('#ringDevice').on('change',function() {
        localStorage.setItem("RingerDevice", this.value);
        //parent.sonido.ring.setSinkId(this.value);
    });

    $('#noise_suppresion').on('change',function(evt,el) {
        localStorage.setItem("NoiseSuppresion",$(this).prop('checked'));
        myNoiseSuppresion=$(this).prop('checked');
    });

    $('#auto_gain_control').on('change',function(evt,el) {
        localStorage.setItem("AutoGainControl",$(this).prop('checked'));
        myAutoGainControl=$(this).prop('checked');
    });

    $('#echo_cancellation').on('change',function(evt,el) {
        localStorage.setItem("EchoCancellation",$(this).prop('checked'));
        myEchoCancellation=$(this).prop('checked');
    });

    // Ring Sound from FOP2, not from phone
    //parent.sonido.ring.setSinkId(getRingerDevice())

    el = document.getElementById('bell');
    el.setSinkId(getRingerDevice());

    //el = document.getElementById('ringing');
    //el.setSinkId(getRingerDevice());

    $("#contact_filter").keyup(function () {
        var text = $(this).val();
        filterContact(text);
    });

    var t=setInterval(
       function() {
           $('.timer').each(function() {
               line_no = $(this).parent().attr('id').substr(5);
               elapsed = Math.round(Date.now()/1000)-activeCalls[line_no].startTime;
               $('#timer_'+line_no).html(defaultFormat(elapsed));
           });

           $('.timerchat').each(function() {
               startTime = $(this).attr('data-starttime');
               elapsed = Math.round(Date.now()/1000)-startTime;
               $(this).html(defaultFormat(elapsed));
           });
           $('.timeago').each(function() {
               newtime = parent.moment($(this).text()).fromNow();
               $('#msgstartedago'+$(this).attr('id').substring(10)).text(newtime);
           });

           const now = new Date();
           const current = pad2(now.getHours()) + ':' + pad2(now.getMinutes());
           var myname = parent.botonitos[parent.myposition].LABEL;
           $('#status_time').text(current);
           $('#status_name').text(extension+" "+myname);

       } , 1000);

    $('.chatmonitor').on('click',function() {
        //console.log('click on chat monitor');
        getChatMonitor();
    });

    $('.chathistory').on('click',function() {
        history_type='all';
        getChatHistory();
    });

    $('#phonerestart').on('click',function() {
        window.location.reload();
    });

    $(document).on('click','.chathistoryback',function() {
        getChatHistory().then(() => filterHistory());
    });

    $(document).on('click','.hangupbutton',function() {
        line_no = $(this).attr('id').substr(6);
        hangup(line_no);
    });

    $(document).on('click','.holdbutton',function() {
        if($(this).attr('data-disabled')=='true') { console.log("not ready for action"); return; }
        line_no = $(this).attr('id').substr(6);
        if(activeCalls[line_no].isOnHold == true) {
           unhold(line_no);
        } else {
           hold(line_no);
        }
        render();
    });

    $('#chat_transfer_conversation').on('click',function() {
        if($('#chattransferto').val()!='') {
            conversationid = $('#chat_transfer_conversation').data('conversationid');
            transferChat(conversationid,$('#chattransferto').val());
        }
    });

    $('#chat_close_conversation').on('click',function() {
        mycontext = parent.context;
        if(mycontext == 'general') { mycontext=''; }
        closeChat($(this).data('conversationid'),$(this).data('exten'),$(this).data('channel'),$(this).data('did'),$(this).data('sender'),mycontext);
    });

    $('#chat_audiocall').on('click',function() {
        if(selectedContact != '') {
            partes = selectedContact.split('_');
            partes.pop();
            dial(partes.pop());
        }
    });

    $('#chat_clear').on('click',function() {
        if(selectedContact != '') {


            event.preventDefault();
            parent.alertify.set({
                 labels: {
                     ok: parent.lang.yes,
                     cancel: parent.lang.no
                 }
            });
            parent.alertify.confirm(parent.lang.areyousure, function(e) {
                if (e) {
                    console.log("todo clear history for conversations from "+parent.myextension+" with "+selectedContact);
                    var conversation = $('#contact_'+selectedContact).data('conversationid');
                    fetch('../menu/api.php?action=clearHistory&conversation='+conversation).then((response)=>response.json()).then((data)=> {
                        if(data.status=='OK') {
                            $('#chat_'+selectedContact).html('');
                        }
                    });
                }
            });

            // todo confirm clear history
        }
    });


    $(document).on('paste','#lbl_enteryourmessage',function(event) {
        console.log('paste en el chat');
        const items = (event.clipboardData || event.originalEvent.clipboardData).items;
        items.forEach((item) => {
            if (item.kind === 'file') {
                // adds the file to your dropzone instance
                myDrop.addFile(item.getAsFile())
            }
        })
    });

    $(document).on('click','.chataccept',function() {
        console.log('click on chat accept');
        //var id = $(this).attr('id').substr(11);
        console.log($(this).data('icon'));
        console.log($(this).data('conversationid'));
        acceptChat(parent.myextension,$(this).data('icon'),$(this).data('conversationid'),$(this).data('channel'),$(this).data('crm'));
    });

    $(document).on('click','tr.trchatmonitor',function() {
        conversationid = $(this).attr('id').substr(10);
        chatid = $(this).data('chatid');
        channel = $(this).data('channel');
        $('#chatmonitor_main table').hide();
        $('#chatmonitor_main').data('currentconversation',conversationid);
        getConversationFromQueue(conversationid,chatid,$(this).data('icon'),$(this).data('sender'),$(this).data('tag'),2,channel);
        $('#chat_transfer_conversation').data('conversationid',conversationid).css('display','inline-block'); // show transfer icon on chat monitor so admin can transfer chats
        $('.chattransfer').show();
        $('.btnattachmenu').hide();
        $('#pttButton').hide();
        $('#controls').hide();
        // XXXXXX chat_transfer_con
    });

    $(document).on('click','tr.trchathistory',function() {
        conversationid = $(this).attr('id').substr(10);
        chatid = $(this).data('chatid');
        channel = $(this).data('channel');
        $('#chathistory_main table').hide();
        getConversationFromQueue(conversationid,chatid,$(this).data('icon'),$(this).data('sender'),$(this).data('tag'),1,channel);
    });

    $(document).on('click','.extencontact',async function() {

        var exten          = $(this).attr('data-contact');
        var fromqueue      = $(this).attr('data-fromqueue');
        var allowaudiocall = $(this).attr('data-audiocall');
        var conversationid = $(this).attr('data-conversationid');
        var capabilities   = $(this).attr('data-capabilities');
        var ptt            = $(this).attr('data-ptt');
        var tag            = $(this).attr('data-tag');
        var channel        = $(this).attr('data-channel');
        var did            = $(this).attr('data-did');
        var phonenumber    = $(this).attr('data-phonenumber');
        var name           = parent.Base64.decode($(this).attr('data-name'));
        tag_index = channel+"_"+did;
        console.log(provider_tags);
        console.log("provider tags index="+tag_index);
        var available_tags = provider_tags[tag_index];
        console.log(available_tags);

        console.log("click on contact "+exten);

        if(tag!='openchannel') {
            enableChatActionButtons(exten);

            // set channel tags - not anymore, it is done in metadatatable
            /*
            $('#conversationtag').select2('destroy');
            $('#conversationtag').find('option').remove().end();
            if(available_tags !== undefined) {

              $('#conversationtag').append($('<option>', {
                value: '',
                text: ''
              }));

              available_tags.split(",").map(function(val) {
                $('#conversationtag').append($('<option>', {
                  value: val,
                  text: val
                }));
              });
            }
            $('#conversationtag').val('');
            $select = $('#conversationtag').select2({ minimumResultsForSearch: -1, placeholder: parent.lang['Tag'] });
            $select.data('select2').$container.addClass('conversationtag').hide();
            */

        }

        $('#menu_chat_history').html(parent.lang['menu_chat_history']);
        $('#chat_contact_name').text(name);
        $('.contacthistory').hide();
        $('#voicemail_main').hide();
        $('#history_close').hide();
        $('#msger-chat').removeClass('msger-history').addClass('msger-chat').removeClass('msger-monitor').removeClass('msger-voicemail');
        $('.extencontact').removeClass('selected');
        $('#contact_'+exten).addClass('selected');
        $('.contactchat').hide();
        $('#chat_'+exten).show();
        $('#msgcount_'+exten).text('');
        $('#chat_'+exten+' .unread').removeClass('unread');
        $('#msger-chat').scrollTop($('#msger-chat')[0].scrollHeight);
        $('.msger-inputarea').show();
        $('.msger-whisper').hide();
        $('.msger-input').show();
        $('#historysearch').hide();
        $('#omniplayer').hide();
        $('.msger-send-btn i').removeClass('fa-sticky-note').addClass('fa-paper-plane').css('color','#FFF');
        $('.msger-send-btn').css('background-color','#ccc');

        if(ptt=='on') {
            $('#pttButton').show();
            $('#controls').show();
        } else {
            // off or undefined
            $('#pttButton').hide();
            $('#controls').hide();
        }

        if(capabilities=='sms') {
            // sms = only text messages
            $('.btnattachmenu').hide();
            $('.typefile').addClass('hidden');
            $('.typeimage').addClass('hidden');
            $('.typesticker').addClass('hidden');
        } else if(capabilities=='mms'){
            // mms = text and image attachments
            $('.btnattachmenu').show();
            $('.typefile').addClass('hidden');
            $('.typeimage').removeClass('hidden');
            $('.typesticker').addClass('hidden');
        } else if(capabilities=='full'){
            // full = text, image, documents and stickers
            $('.btnattachmenu').show();
            $('.typefile').removeClass('hidden');
            $('.typeimage').removeClass('hidden');
            $('.typesticker').removeClass('hidden');
        } else {
            $('.btnattachmenu').hide();
            $('.typefile').addClass('hidden');
            $('.typeimage').addClass('hidden');
            $('.typesticker').addClass('hidden');
        }

        if($('#lbl_enteryourmessage').val()!='') {
            $('.msger-send-btn').css('background-color','#00c441');
        } else {
            if(myDrop.getQueuedFiles().length==0) {
                $('.msger-send-btn').css('background-color','#ccc');
            }
        }

        firstname=$('#chat_contact_name').text().split(" ")[0];
        lastname=$('#chat_contact_name').text().split(" ")[1];

        if(channel == 'internal') {
            //$('#chat_clear').show();
            $('#chat_clear').css('display','inline-block');
        } else {
            $('#chat_clear').hide();
        }

        console.log("exten "+exten+" selectedContact "+selectedContact+' channel '+channel);

        if(exten != selectedContact) {

            myDrop.removeAllFiles(); // remove dropzone when clicking a different/new contact

            $('#menu_view_contact').hide();
            $('#menu_add_contact').hide();
            await doesContactExists(exten.split('_').pop(),firstname,lastname,channel).then((data)=>{
                jsondata = JSON.parse(data);
                console.log(jsondata);
                if(jsondata.id>=0) {
                    $('#menu_view_contact').attr('data-contactid',jsondata.id).show();
                    if(jsondata.color!='') {
                        // set color to some element
                        //$('.msger-header').css('background','linear-gradient('+jsondata.color+' 0%,#fff 20%)');
                        $('.msger-header').css('background','linear-gradient('+jsondata.color+' 0%,#fff 10%, #fff 90%, '+jsondata.color+' 100%)');
                    } else {
                        $('.msger-header').css('background','').css('background-color','#fff');
                    }
                } else {
                    if(parent.permisos.includes('all') || parent.permisos.includes('phonebook')) {
                        $('#menu_add_contact').show();
                    }
                    $('.msger-header').css('background','').css('background-color','#fff');
                }
            });

            console.log('channel '+channel);

            if(channel=='internal') {
                mycontext = parent.context;
                if(mycontext == 'general') { mycontext=''; }

                // Manipulate internal to make it backwards compatible, remove the _did part
                var internal_exten = exten;
                var lastIndex = exten.lastIndexOf("_");
                if (lastIndex !== -1) {
                    internal_exten = exten.substring(0, lastIndex);
                }
                console.log("canal internal, verificar si existe convresacion en DB assigned to="+internal_exten);
                // create conversation in DB if it does not exists and set data-conversationid attribute to contact
                pocketclient.collection('incomingqueue').getList( 1, 50, {
                filter: 'state = "open" && channel = "internal" && sender = "internal_'+parent.myextension+'" && assignedto = "'+internal_exten+'"',
                }).then((result)=>{
                    if(result.items.length == 0) {
                        console.log("no existe internal con sender internal_"+parent.myextension+" y assigned a "+internal_exten);
                        const qdata = {
                            "sender": 'internal_'+parent.myextension,
                            "channel": 'internal',
                            "assignedto": internal_exten,
                            "state": "open",
                            "did": 'internal', // TODO was exten
                            "icon": '',
                            "chatid": 'internal_'+parent.myextension+"-"+internal_exten,
                            "avatar": '',
                            "phonenumber": '',
                            "tag": '',
                            "context": mycontext,
                            "finished":''
                        }
                        const record = pocketclient.collection('incomingqueue').create(qdata).then((record)=>{
                            console.log("creada conversacion origen");
                            console.log(record);
                            $('#contact_'+exten).attr('data-conversationid',record.id);
                        });
                    } else {
                        console.log("conversacion origen existe");
                        console.log(result.items[0]);
                        $('#contact_'+exten).attr('data-conversationid',result.items[0].id);
                    }
                }).then(()=>{
                    // create conversation for destination extension in DB if it does not exists, do not set data-conversationid
                    pocketclient.collection('incomingqueue').getList( 1, 50, {
                    filter: 'state = "open" && context = "'+mycontext+'" && channel = "internal" && sender = "'+internal_exten+'" && assignedto = "internal_'+parent.myextension+'"',
                    }).then((result)=>{
                        if(result.items.length == 0) {
                            console.log("no existe con sender "+internal_exten+" y con assigned internal_"+parent.myextension);
                            const qdata = {
                                "sender": internal_exten,
                                "channel": 'internal',
                                "assignedto": 'internal_'+parent.myextension,
                                "state": "open",
                                //"did": 'internal_'+parent.myextension,
                                "did": 'internal',
                                "icon": '',
                                "chatid": internal_exten+"-internal_"+parent.myextension,
                                "avatar": '',
                                "phonenumber": '',
                                "tag": '',
                                "context": mycontext,
                                "finished":''
                            }
                            const record = pocketclient.collection('incomingqueue').create(qdata).then((record)=>{
                                console.log("creada conversacion destino");
                                console.log(record);
                                $('#contact_'+exten).attr('data-conversationid2',record.id);
                            });
                        } else {
                            $('#contact_'+exten).attr('data-conversationid2',result.items[0].id);
                        }
                    });
                });
            }
        }

        selectedContact = exten;
        if(typeof(phonenumber)=='undefined' || phonenumber=='undefined') {
            selectedPhoneNumber = exten;
        } else {
            selectedPhoneNumber = phonenumber;
        }

        if($('#contact_'+exten).data('closed')!='closed') {
            $('.enachatinput').removeAttr('disabled');
            $('.chatpart').removeClass('disabled');
        } else {
            $('.enachatinput').attr('disabled','disabled');
            $('.chatpart').addClass('disabled');
        }
        if(allowaudiocall==1 || allowaudiocall=='on') {
            $('#chat_audiocall').css('display','inline-block');
        } else {
            $('#chat_audiocall').hide();
        }

        if(fromqueue=='yes' && tag!='openchannel') {
            $('#chat_close_conversation').data('conversationid',conversationid).data('exten',exten).data('channel',channel).data('did',did).data('sender',$('#chat_contact_name').text()).css('display','inline-block');
            $('#chat_transfer_conversation').data('conversationid',conversationid).data('exten',exten).css('display','inline-block');
            $('#chat_menu').data('conversationid',conversationid).data('exten',exten).css('display','inline-block');
            $('#conversationtag').data('conversationid',conversationid).val(tag);
            $('#conversationtag').data('nochange',1).trigger('change');
            $('.conversationtag').show();
            $('.btnattach').show();
            $('#chattransferto').val(null).trigger('change');
            $('.chattransfer').show();
        } else {
            $('#chat_close_conversation').hide();
            $('#chat_transfer_conversation').hide();
            $('#chat_menu').hide();
            $('.chattransfer').hide();
            $('.btnattach').show();
            $('.conversationtag').hide();
        }
        $('#header_chat_icon').removeClass('fa-history').addClass('fa-comment-alt').removeClass('fa-inbox').removeClass('fa-desktop');
    });

    $('.msger-inputarea').on('submit',function(event) {
        event.preventDefault();

        //close emoji box slideUp
        if($('#emojibox').is(':visible')==true) {
            $('#emojibox').slideUp('fast',function() { console.log('fin');});
            $('.smileybtn').removeClass('fa-window-close').addClass('fa-smile');
        }

        if($('.msger-input').is(':visible') || $('#audioblob').length>0) {
            const msgText = $('.msger-input').val().replace(/[\s\n]+$/g,'');
            channel = $('#contact_'+selectedContact).data('channel');
            console.log(msgText.length);
            console.log("tengo text ("+msgText+")");
            $('.msger-input').val('');
            if ((!msgText || msgText.trim()=='') && myDrop.getQueuedFiles().length==0 && $('#audioblob').length==0) { return; }
            sendSIPMessage(selectedPhoneNumber, msgText, channel);
            console.log("sent sip message to "+selectedPhoneNumber);

        } else
        if($('.msger-whisper').is(':visible')) {
            const msgText = $('.msger-whisper').val();
            $('.msger-whisper').val('');
            if (!msgText || msgText.trim()=='') { console.log('esta vacio'); return; }
            sendPrivateNote(msgText);
        }
    });

    $(document).on('click','.mutebutton',function() {
        console.log($(this).attr('data-disabled'));
        if($(this).attr('data-disabled')=='true') { console.log("not ready for action"); return; }
        line_no = $(this).attr('id').substr(6);
        if(activeCalls[line_no].isMuted == true) {
           unmute(line_no);
        } else {
           mute(line_no);
        }
        render();
    });

    $(document).on('click','.btnanswer',function(evt) {
        line_no = $(this).attr('id').substr(7);
        answer(line_no);
    });

    $(document).on('click','.btnreject',function(evt) {
        line_no = $(this).attr('id').substr(7);
        reject(line_no);
    });

    $(document).on('click','.transferbutton',function(evt) {
        if($(this).attr('data-disabled')=='true') { console.log("not ready for action"); return; }
        line_no = $(this).attr('id').substr(6);
        $('#actionbuttons_'+line_no).slideUp();
        $('#transferbox_'+line_no).slideDown();
        $('#target_'+line_no).focus();
        hold(line_no);
    });

    $(document).on('click','.canceltransfer',function(evt) {
        line_no = $(this).attr('id').substr(11);
        $('#transferbox_'+line_no).slideUp();
        $('#actionbuttons_'+line_no).slideDown();
        unhold(line_no);
    });

    $(document).on('click','.conferencebutton',function(evt) {
        if($(this).attr('data-disabled')=='true') { console.log("not ready for action"); return; }
        line_no = $(this).attr('id').substr(6);
        $('#actionbuttons_'+line_no).slideUp();
        $('#conferencebox_'+line_no).slideDown();
        $('#target_'+line_no).focus();
        hold(line_no);
    });

    $(document).on('click','.cancelconference1',function(evt) {
        line_no = $(this).attr('id').substr(10);
        $('#conferencebox_'+line_no).slideUp();
        $('#actionbuttons_'+line_no).slideDown();
        unhold(line_no);
    });

    if(parent.pluginconfig['phonepro']['force_autoanswer']['']==1) {
        $('#autoanswer').attr('disabled','disabled');
        autoanswer = 'on';
    } else {
        $('#autoanswer').removeAttr('disabled');
        $('#autoanswer').on('change',function() {
            var check = document.getElementById('autoanswer').checked;
            var val   = 'off'
            if(check==true) { val='on'; } else { val='off'; }
            localStorage.setItem("autoanswer", val);
            autoanswer = val;
        });
    }

    $('#intercom').on('change',function() {
        var check = document.getElementById('intercom').checked;
        var val   = 'off'
        if(check==true) { val='on'; } else { val='off'; }
        localStorage.setItem("intercom", val);
        intercom = val;
    });

    $('#callwaiting').on('change',function() {
        var check = document.getElementById('callwaiting').checked;
        var val   = 'off'
        if(check==true) { val='on'; } else { val='off'; }
        localStorage.setItem("callwaiting", val);
        callwaiting = val;
    });

    $(document).on('click','.stransfer',function(evt) {
        //evt.stopPropagation();
        line_no = $(this).attr('id').substr(13);
        nbr = $('#target_'+line_no).val().replace(/\s/g, '');
        if(nbr!='') {
           let isnum = /^\d+$/.test(nbr);
           if(isnum) {
              supervised_transfer(line_no,nbr);
           } else {
              setFooterText(parent.lang.onlydigitsallowedtransfer);
           }
        }
    });

    $(document).on('click','.btransfer',function(evt) {
        //evt.stopPropagation();
        line_no = $(this).attr('id').substr(13);
        nbr = $('#target_'+line_no).val().replace(/\s/g, '');
        if(nbr!='') {
           let isnum = /^\d+$/.test(nbr);
           if(isnum) {
               blind_transfer(line_no,nbr);
           } else {
               setFooterText(parent.lang.onlydigitsallowedtransfer);
           }
        }
    });

    $(document).on('click','.bconference',function(evt) {
        line_no = $(this).attr('id').substr(14);
        nbr = $('#conftarget_'+line_no).val().replace(/\s/g, '');
        if(nbr!='') {
           let isnum = /^\d+$/.test(nbr);
           if(isnum) {
               conference(line_no,nbr);
           } else {
               setFooterText(parent.lang.onlydigitsallowedtransfer);
           }
        }
    });

    $(document).on('click','.liline',function() {
        line_no = $(this).attr('id').substr(5);
        selectLine(line_no);
        render();
    });

    $('.talk-bubble').on('click',function() {
        $(this).hide();
    });

    $('#dialbutton').on('click',function() {
        output = $('#output').val();
        if(output!='') {
             dial(output);
             $('#output').val('');
             toggleBackspace();
             $('.drawer').removeClass('open-drawer');
             $('.closedrawer').hide();
             $('.showdialpad').show();
             $('.showaudiosettings').show();
             $('.showpreferences').show();
             $('.chathistory').show();
             $('.chatmonitor').show();
             hideShowMwi('show');
        }
    });

    $('.showdialpad').on('click',function() {
        if($('.drawer').hasClass('open-drawer')) {
            $('.drawer').removeClass('open-drawer');
            stopMicrophoneMeterStream();
            $('.closedrawer').hide();
            $('.showdialpad').show();
            $('.showaudiosettings').show();
            $('.showpreferences').show();
            $('.chathistory').show();
            $('.chatmonitor').show();
            hideShowMwi('show');
        } else {
            stopMicrophoneMeterStream();
            $('.wrap-diapad').show();
            $('.preferences').hide();
            $('.settings').hide();
            $('.drawer').addClass('open-drawer');
            $('.closedrawer').show();
            $('.showdialpad').hide();
            $('.showaudiosettings').hide();
            $('.showpreferences').hide();
            $('.chathistory').hide();
            $('.chatmonitor').hide();
            hideShowMwi('hide');
        }
    });

    $('.closedrawer').on('click',function() {
        $('.drawer').removeClass('open-drawer');
        $('.closedrawer').hide();
        $('.showdialpad').show();
        $('.showaudiosettings').show();
        $('.showpreferences').show();
        $('.chathistory').show();
        $('.chatmonitor').show();
        hideShowMwi('show');
    });

    $('.showaudiosettings').on('click',function() {
        if($('.drawer').hasClass('open-drawer')) {
            $('.drawer').removeClass('open-drawer');
            stopMicrophoneMeterStream();
            $('.closedrawer').hide();
            $('.showdialpad').show();
            $('.showaudiosettings').show();
            $('.chathistory').show();
            $('.chatmonitor').show();
            hideShowMwi('show');
        } else {
            $('.wrap-diapad').hide();
            $('.preferences').hide();
            $('.settings').show();
            displayMeter();
            $('.drawer').addClass('open-drawer');
            $('.closedrawer').show();
            $('.showdialpad').hide();
            $('.showaudiosettings').hide();
            $('.showpreferences').hide();
            $('.chathistory').hide();
            $('.chatmonitor').hide();
            hideShowMwi('hide');
        }
    });

    $('.showpreferences').on('click',function() {
        if($('.drawer').hasClass('open-drawer')) {
            $('.drawer').removeClass('open-drawer');
            stopMicrophoneMeterStream();
            $('.closedrawer').hide();
            $('.showdialpad').show();
            $('.showaudiosettings').show();
            $('.showpreferences').show();
            $('.chathistory').show();
            $('.chatmonitor').show();
            hideShowMwi('show');
        } else {
            $('.wrap-diapad').hide();
            $('.settings').hide();
            $('.preferences').show();
            displayMeter();
            $('.drawer').addClass('open-drawer');
            $('.closedrawer').show();
            $('.showdialpad').hide();
            $('.showaudiosettings').hide();
            $('.showpreferences').hide();
            $('.chathistory').hide();
            $('.chatmonitor').hide();
            hideShowMwi('hide');
        }

    });

    $('#dndbadge').on('click',function() {
        dial(dndcode);
    });

    $('#qloginbadge').on('click',function() {
        dial(queuelogincode);
    });

    $('.showmwi').on('click',function() {
        if(extenVoicemail!='') {
            if(mwidisabled==false) {
                mwidisabled=true;
                if(parent.plugins['phonepro'].hasVoicemailLicense()==1) {
                    showVoicemail();
                } else {
                    dial(extenVoicemail);
                }
                setTimeout(function() { mwidisabled=false; },2000);
            }
        }
    });

    $('.diapad-key').on('click',function(evt) {
        num = $(evt.currentTarget).data('digit');
        clicknum(num+'');
    });

    // handle keyboard for dialplad
    $( document ).on('keyup', function( event ) {
        processKey(event);
    });

    if(self!==top) {
        // handle keyboard from parent window if phone is embeded inside iframe
        $( parent.document).on('keyup', function (event) {
            processKey(event);
        });

        $( parent.document.scripterframe).on('keyup', function (event) {
            processKey(event);
        });
    }

    // click backspace dialpad
    $('#backspace').on('click', function() {
        current = $('#output').val();
        $('#output').val(current.slice(0,-1));
        toggleBackspace();
    });

    // allow only 0-9 digits for transfer target input box
    $(document).on('input blur keyup paste', '.transfertarget', function() {
        $(this).val(function(i, v) {
            return v.replace(/[^0-9]/ig, '');
        });
    });

    // allow digits, hash and asterisk on dialout input box
    $('#output').on('input blur keyup paste', function() {
        $(this).val(function(i, v) {
            return v.replace(/[^0-9#*]/ig, '');
        });
    });

    $('[data-toggle="tooltip"]').tooltip();

    setText();

    if(myEchoCancellation=='false') {
        $('#echo_cancellation').prop('checked','');
    } else {
        $('#echo_cancellation').prop('checked','checked');
    }

    if(myAutoGainControl=='false') {
        $('#auto_gain_control').prop('checked','');
    } else {
        $('#auto_gain_control').prop('checked','checked');
    }

    if(myNoiseSuppresion=='false') {
        $('#noise_suppresion').prop('checked','');
    } else {
        $('#noise_suppresion').prop('checked','checked');
    }

    if(autoanswer=='on') {
        $('#autoanswer').prop('checked','checked');
    } else {
        $('#autoanswer').prop('checked','');
    }

    if(intercom=='on') {
        $('#intercom').prop('checked','checked');
    } else {
        $('#intercom').prop('checked','');
    }

    if(callwaiting=='on') {
        $('#callwaiting').prop('checked','checked');
    } else {
        $('#callwaiting').prop('checked','');
    }

    fetch('../menu/api.php?action=getQuickReplies').then((response)=>response.json()).then((data)=> {
        quick_replies = data; //list

        $('#lbl_enteryourmessage').autocomplete({
            lookup: quick_replies,
            orientation: 'top',
            formatResult: function(suggestion,currentValue) {
                return suggestion.value+' : '+suggestion.data;
            },
            onSelect: function (suggestion) {
                $('#lbl_enteryourmessage').val(suggestion.data);
            }
        });

    });

    $('#tabnav').tab();

    $('#tabnav a').on('shown.bs.tab', function (e) {
        var target = $(e.target).attr("href")
        console.log(target);
    });

    doTrans();

    mylang = 'en';
    var my1lang = parent.language;
    if(my1lang!==null) {
        mylang = my1lang.split("_")[0];
    }

    parent.moment.locale(mylang);

});

function doTrans() {
    $('[data-trans]').each(function() {
         if(typeof(parent.lang[$(this).data('trans')])!='undefined') {
              newtext = parent.lang[$(this).data('trans')];
         } else {
             newtext = $(this).data('trans');
         }
         //console.log("trans "+$(this).data('trans'));
         $(this).text(newtext);
    });
}

function compareVersions(version1, version2) {
    const v1Parts = version1.split('.').map(Number);
    const v2Parts = version2.split('.').map(Number);
    for (let i = 0; i < Math.max(v1Parts.length, v2Parts.length); i++) {
        const v1Part = i < v1Parts.length ? v1Parts[i] : 0;
        const v2Part = i < v2Parts.length ? v2Parts[i] : 0;

        if (v1Part < v2Part) {
            return "lower";
        } else if (v1Part > v2Part) {
            return "higher";
        }
    }
    return "equal";
}

