var userAgent;
var registerer;
var hasMWI               = false;
var supportedConstraints = {};

var myNoiseSuppresion    = getNoiseSuppresion();
var myAutoGainControl    = getAutoGainControl();
var myEchoCancellation   = getEchoCancellation();

var autoanswer           = getAutoanswer();
var intercom             = getIntercom();
var callwaiting          = getCallwaiting();
var myRingtone           = getRingtone();

//parent.consoleDebug = false;

//var blf                  = JSON.parse(localStorage.getItem('blf'));
//var dndcode              = '*76';
//var queuelogincode       = '*45';
if(dndcode===undefined) {
    dndcode='*76';
}
var blf                  = {};
blf[dndcode+extension]='DND';
blf[queuelogincode+'*'+extension]='Queue';

$('#bell').attr('src','sounds/'+myRingtone+'.mp3');
$('#ringtone option[value='+myRingtone+']').prop('selected', true);

const uri = SIP.UserAgent.makeURI("sip:"+extension+"@"+host);
if (!uri) { renderRegister("offline"); setFooterText(parent.lang.baduseragenturi); throw new Error("Failed to create URI"); }

const reconnectionAttempts = 3000;
const reconnectionDelay    = 5;
var reconnectingAttempts = reconnectionAttempts;
var registering            = false;
let attemptingReconnection = false;
let shouldBeConnected      = true;
var registrationCompleted  = false;

var selectedLine           = 0;
var selectedContact        = 0;
var selectedPhoneNumber    = '';
var activeCalls            = {};
var subscriber             = {};
var failinsecure=false;
if(window.location.protocol=='http:') {
   failinsecure=true;
}

let constraintsDefault = {
    audio: true,
    video: false,
}

micDevice = getMicDevice();
if(micDevice!='default') {
    delete constraintsDefault.audio;
    constraintsDefault.audio = {};
    constraintsDefault.audio.deviceId = { exact: micDevice }
}

var userAgentOptions = {
    //allowLegacyNotifications: true,
    forceRport: false,
    displayName: parent.botonitos[parent.myposition]['LABEL'],
    contactParams: { transport: "wss" },
    registerExpires: 30,
    uri: uri,
    authorizationPassword: secret,
    autoStart: false,
    autoStop: true,
    register: false,
    logLevel: "none",
    hackIpInContact: true,
    transportOptions : {
        traceSip: true,
        server: wsServer,
        connectionTimeout: 30
    },
    noAnswerTimeout: 120,
    sipExtension100rel: true,
    userAgentString: "fop2-digium-compatible-ua",
    sessionDescriptionHandlerFactoryOptions : {
        iceGatheringTimeout : 500,
        //rtcpMuxPolicy: "negotiate",
        constraints: constraintsDefault,
        peerConnectionConfiguration : {
            //iceServers : [ { urls: ['stun:stun.stunprotocol.org:3478' ] }]
            iceServers : [ ]
        },
    },
};

try {

    userAgent = new SIP.UserAgent(userAgentOptions);
    userAgent.isRegistered = function(){
        return (userAgent && registerer && registerer.state == SIP.RegistererState.Registered);
    }

    userAgent.transport.onDisconnect = function(error){
        if(error){
            console.log("transport error, show offline");
            renderRegister('offline');
            setFooterText(parent.lang.error_websocket);
            unregister();
            attemptReconnection();
        }
        else {
            renderRegister('offline');
            setFooterText(parent.lang.error_websocket);
            console.log("transport disconnected, show offline");
        }
    }

    userAgent.transport.onConnect = function(data){
        transportConnected();
    }

    registerer = new SIP.Registerer(userAgent, { expires:30 });

    registerer.stateChange.addListener(function(newState){
        console.log("UserAgent registration state: "+newState);
        switch (newState) {
            case SIP.RegistererState.Initial:
                // Do nothing
                console.log("registerer initial, do nothing");
                break;
            case SIP.RegistererState.Registered:
                console.log("registerer registered!!");
                onRegistration();
                break;
            case SIP.RegistererState.Unregistered:
                console.log("registerer unregistered!!");
                onUnregistration();
                break;
            case SIP.RegistererState.Terminated:
                console.log("registerer terminated!!");
                // Try to register again NICO
                register();
                break;
            default:
                console.log("registered default");
                console.log(SIP.RegistererState);
                break;
        }
    });

    userAgent.delegate = {
        onInvite: function(invitation) {

            // An Invitation is a Session
            const incomingSession = invitation;

            if(Object.keys(activeCalls).length>0 && callwaiting=='off') {
                setFooterText(parent.lang['reject_call_waiting']);
                incomingSession.reject();
                return;
            }

            if(Object.keys(activeCalls).length>3) {
                setFooterText(parent.lang['reject_max_lines']);
                incomingSession.reject();
                return;
            }

            autoAnswer = -1;
            if(intercom=='on') {
                if(invitation.request.headers['Alert-Info']!==undefined) {
                    if(invitation.request.headers['Call-Info']!==undefined) {
                        var callInfo  = invitation.request.headers['Call-Info'][0]['raw'];
                        var regex = /answer-after=(.*)/;
                        var matches = callInfo.match(regex);
                        autoAnswer = parseInt(matches[1]);
                    }
                }
            }

            next_line = nextLine();
            activeCalls[next_line]=incomingSession;
            activeCalls[next_line].isOnHold = false;
            activeCalls[next_line].isMuted = false;
            activeCalls[next_line].Inviter = false;
            activeCalls[next_line].lineNumber = next_line;
            activeCalls[next_line].sessdata = {};
            activeCalls[next_line].sessdata.AudioSourceTrack=null;
            setFooterText(sprintf(parent.lang['incoming_call_on_line'],next_line));

            from_number = activeCalls[next_line].remoteIdentity.uri.raw.user
            first_option = $("#callhistory option:first").val();
            if(first_option != from_number) {
                $('#callhistory').prepend("<option value='" + from_number + "'>");
                if($('#callhistory option').length>10) {
                    $('#callhistory option:last').remove();
                }
            }
 
            // Setup incoming session delegate
            incomingSession.delegate = {
                // Handle incoming REFER request.
                onRefer: function() {
                    // ...
                }
            };

            lineObj = activeCalls[next_line];
            // Handle incoming session state changes.
            incomingSession.stateChange.addListener((newState) => {
                //line_no = find_line_from_id(incomingSession._id);
                //console.log("incoming session first method line no = "+line_no);

                line_no = lineObj.lineNumber;
                console.log("incoming session second method line no = "+lineObj.lineNumber);
                switch (newState) {
                    case SIP.SessionState.Establishing:
                        // Session is establishing.
                        console.log('incoming establishing session '+line_no);
                        activeCalls[line_no].startTime = Math.floor(Date.now()/1000);
                        el = document.getElementById('bell');
                        el.pause();
                        render();
                        break;
                    case SIP.SessionState.Established:
                        // Session has been established.
                        console.log('incoming established session '+line_no);
                        console.log(incomingSession);
                        setupRemoteMedia(line_no,incomingSession._sessionDescriptionHandler);
                        activeCalls[line_no].startTime = Math.floor(Date.now()/1000);
                        selectLine(line_no);
                        render();
                        break;
                    case SIP.SessionState.Terminated:
                        // Session has terminated.
                        console.log("incoming session terminated "+line_no);
                        el = document.getElementById('bell');
                        el.pause();

                        line_no = 0;
                        Object.keys(activeCalls).forEach(id => {
                            console.log(id,activeCalls[id]._state);
                            if(activeCalls[id]._state == SIP.SessionState.Terminated) {
                                cleanupMedia(id);
                                line_no=id;
                                setFooterText(sprintf(parent.lang['call_ended_on_line'],line_no));
                                console.log("clean up media "+id);
                                const el = document.getElementById('ringing');
                                if(!el.paused) { el.pause(); }
                            }
                        });
                        if(line_no>0) {
                            delete activeCalls[line_no];
                            console.log("delete activecalls["+line_no+"]");
                            if(selectedLine==line_no) {
                                selectFirstLine();
                            }
                        }
 
                        render();
                        break;
                    default:
                        break;
                }
            });

            if(autoAnswer<0) {
                if(autoanswer=='on') {
                    autoAnswer=0;
                }
            }

            if(autoAnswer>=0 && Object.keys(activeCalls).length==1) {
                setTimeout(function() { incomingSession.accept(); render(); }, autoAnswer*1000);
            } else {
                if(Object.keys(activeCalls).length==1) {
                   // play ring if we are not on a call
                   el = document.getElementById('bell');
                   el.setSinkId(getRingerDevice());
                   el.play().catch(function() { console.log('error playing incoming call ring audio');});
                }
                render();
            }

        },
        onConnect: function() {
            setFooterText(parent.lang.connected);
            renderRegister("registered");
        },
        onDisconnect: function() {
            console.log("registerer onDisconnect, will unregister");
            setFooterText(parent.lang.disconnected);
            renderRegister("offline");
    
            registerer.unregister()
                .catch((error) => {
                  // Unregister failed
                });
            console.log("onDisconnect, registerer unregister done error = "+error);
            // Only attempt to reconnect if network/server dropped the connection (if there is an error)
            if (error) {
                console.log("onDisconnect, registerer will attemptReconnection because error is true");
                attemptReconnection();
            } else {
                console.log("onDisconnect, registerer no reconnection as there is no error");
            }
        },
        onNotify: function(r) {
            console.log("on notify start");
            var newMessages = 0;
            var oldMessages = 0;
            var gotmsg = r.request.body.match(/voice-message:\s*(\d+)\/(\d+)/i);
            var voicemailDial = r.request.body.match(/message-account:\s*(.*)/i);

            if(voicemailDial !== null) {
                extenVoicemail = voicemailDial[1].split(":")[1].split('@')[0];
            }
            if (gotmsg) {
                console.log("voicemail notification");
                newMessages = parseInt(gotmsg[1]);
                oldMessages = parseInt(gotmsg[2]);
                var total = newMessages + oldMessages;
                if(total==0) {
                    hasMWI = false;
                    $('.mwi').text('');
                    hideShowMwi('hide');
                } else {
                    hasMWI = true;
                    hideShowMwi('show');
                    if(newMessages>0) {
                        $('.mwi').text(newMessages);
                    } else {
                        $('.mwi').text('');
                    }
                }
            } else {
                console.log("other notification");
                //console.log(r.request.body);
                //console.log(r.request.headers);
                // Check sip notify for answer button plugin
                var header = r.request.headers.Event[0].raw;
                if(header == 'answer=true') {
                    Object.keys(activeCalls).forEach(id => {
                        var state = activeCalls[id]._state;
                        var inv   = activeCalls[id].Inviter;
                        if(inv==false) {
                            if(state == 'Initial') {
                                answer(id);
                            }
                        }
                    });
                }
            }
        },
        onMessage: function(msg) {
            console.log(msg.request);
            var from   = msg.request.from.displayName;
            var number = msg.request.from.uri.normal.user;
            var body   = msg.request.body;
            var msgqueueid = '';
            if(typeof(msg.request.headers['X-Queue-Id'])!='undefined') {
                msgqueueid = msg.request.headers['X-Queue-Id'][0].raw;
            }
            var channel = '';
            if(typeof(msg.request.headers['X-Channel'])!='undefined') {
                channel = msg.request.headers['X-Channel'][0].raw;
            }

            if(number.indexOf("<")>0) {
                var exp = /([^<]+)<([^>]+)>/ig;
                var name = number.replace(exp, "$1").trim();
                var newnumber = number.replace(exp, "$2").trim();
                number = newnumber;
            }
            console.log(msg.request.from);
            console.log("Recibió un mensaje from: "+from+", name: "+name+", number: "+number+", body: "+body+", channel: "+channel+", msgqueueid: "+msgqueueid);
            var finalfrom = '';
            if(typeof(from)!='undefined') {
                finalfrom+=from;
            } else {
                finalfrom=(typeof(name)!='undefined')?name:number;
            }
            seed = finalfrom.replace(/[\u{0080}-\u{FFFF} ]/gu,"");
            var msgid = uuidv4();

            avatar_contact = (channel=='internal')?number:name;
            console.log("avatar contact "+avatar_contact);

            if(avatar_contact=='ServiceCenter') {
                avatar = 'https://avatars.dicebear.com/api/bottts/your-asdf4.svg';
                appendMessage(number, msgid, finalfrom, avatar, 'left', body);
            } else if(msgqueueid==0){
                    // mensaje intra extension
                    getAvatar(avatar_contact,parent.myextension).then(function(avatar) {
                        appendMessage(number, msgid, finalfrom, avatar, 'left', body, undefined, undefined, undefined, undefined, undefined, undefined, 'internal', 0, 'internal');
                    });
            } else {
                get_message_from_queue(msgqueueid).then(function(msgdata) {
                    let attach = [ msgqueueid, msgdata.attachment ];
                    let did = msgdata.expand.conversation.did;
                    appendMessage(number, msgid, finalfrom, msgdata.avatar, 'left', body, undefined, undefined, undefined, undefined, undefined, attach, channel, 0, did);
                });
            }
        }
    };

    userAgent.start().then(() => {
      // Register the user agent

      /*
      if(parent.isSecure()==true) {
          registerer.register();
      } else {
          renderRegister('offline');
          setFooterText(parent.lang.usehttps);
      }
      */
    }).catch((error)=> { 
         console.log("error user agent start");
         renderRegister('websocket_error');
    });

} catch(e) { 
    renderRegister('offline');
    setFooterText(e);
}


function selectFirstLine() {
    if(Object.keys(activeCalls).length>0) {
        selectLine(Object.keys(activeCalls)[0]);
    }
}

function selectLine(lineNum){

    if(lineNum==selectedLine) return;

    Object.keys(activeCalls).forEach(id => {
        let session = activeCalls[id];
        console.log(session.state);
        if(session.state == SIP.SessionState.Established){
            if(session.isOnHold == false && id != lineNum) {
                hold(id);
            }
        }
    });

    let session = null;
    Object.keys(activeCalls).forEach(id => { if(id==lineNum) { session=activeCalls[id]; }});
    if(session != null) {
        if(session.state == SIP.SessionState.Established){
            if(session.isOnHold == true) {
                unhold(lineNum)
            }
        }
    }
    selectedLine = lineNum;
}

function nextLine() {
    lines=[];
    Object.keys(activeCalls).forEach(id => { lines.push(id)});
    var cont=0;
    for(var i=1;i<=lines.length;i++) {    
        cont++;
        if(lines[i-1] != i){
            return i;
        }
    }
    return cont+1;
}

function answer(line_no) {

    let constrainsDefault = {
        audio: true,
        video: false,
    }

    micDevice = getMicDevice();
    if(micDevice!='default') {
        constraintsDefault.audio.deviceId = { exact: micDevice }
    }

    const options = {
        sessionDescriptionHandlerOptions: {
            constraints: constrainsDefault,
        },
    }

    if(supportedConstraints.autoGainControl) {
        options.sessionDescriptionHandlerOptions.constraints.audio.autoGainControl = myAutoGainControl;
    }
    if(supportedConstraints.echoCancellation) {
        options.sessionDescriptionHandlerOptions.constraints.audio.echoCancellation = myEchoCancellation;
    }
    if(supportedConstraints.noiseSuppression) {
        options.sessionDescriptionHandlerOptions.constraints.audio.noiseSuppression = myNoiseSuppresion;
    }

    activeCalls[line_no].accept(options) 
    setFooterText(sprintf(parent.lang['call_answered_on_line'],line_no));
}

function reject(line_no) {
    activeCalls[line_no].reject();
    setFooterText(sprintf(parent.lang['call_rejected_on_line'],line_no));
}

function dtmf(line_no,digit) {
    const options = {
        requestOptions: {
            body: {
                contentDisposition: "render",
                contentType: "application/dtmf-relay",
                content: "Signal="+digit+"\\r\\nDuration=1000"
            }
        }
    };
    if(typeof(activeCalls[line_no])!="undefined") {
        activeCalls[line_no].info(options);
        setFooterText(sprintf(parent.lang['dtmf_sent'],digit,line_no));
    }
}

function hold(lineNum) {

    console.log('attempt to hold '+lineNum);

    let session = activeCalls[lineNum];
    if(session == null) { console.log('no valid session'); return; }
    if(session.isOnHold == true) {
        console.log("Call is is already on hold:", lineNum);
        return;
    }
    console.log("Putting Call on hold:", lineNum);
    session.isOnHold = true;

    var sessionDescriptionHandlerOptions = session.sessionDescriptionHandlerOptionsReInvite;
    sessionDescriptionHandlerOptions.hold = true;
    session.sessionDescriptionHandlerOptionsReInvite = sessionDescriptionHandlerOptions;

    var options = {
        requestDelegate: {
            onAccept: function(){
                if(session && session.sessionDescriptionHandler && session.sessionDescriptionHandler.peerConnection){
                    var pc = session.sessionDescriptionHandler.peerConnection;
                    // Stop all the inbound streams
                    pc.getReceivers().forEach(function(RTCRtpReceiver){
                        if (RTCRtpReceiver.track) RTCRtpReceiver.track.enabled = false;
                    });
                    // Stop all the outbound streams (especially usefull for Conference Calls!!)
                    pc.getSenders().forEach(function(RTCRtpSender){
                        // Mute Audio
                        if(RTCRtpSender.track && RTCRtpSender.track.kind == "audio") {
                            if(RTCRtpSender.track.IsMixedTrack == true){
                                if(session.sessdata.AudioSourceTrack && session.sessdata.AudioSourceTrack.kind == "audio"){
                                    console.log("Muting Mixed Audio Track : "+ session.sessdata.AudioSourceTrack.label);
                                    session.sessdata.AudioSourceTrack.enabled = false;
                                }
                            }
                            console.log("Muting Audio Track : "+ RTCRtpSender.track.label);
                            RTCRtpSender.track.enabled = false;
                        }
                        // Stop Video
                        else if(RTCRtpSender.track && RTCRtpSender.track.kind == "video"){
                            RTCRtpSender.track.enabled = false;
                        }
                    });
                }
                session.isOnHold = true;
                console.log("Call is is on hold:", lineNum);

            },
            onReject: function(){
                session.isOnHold = false;
                console.warn("Failed to put the call on hold:", lineNum);
            }
        }
    };
    session.invite(options).catch(function(error){
        session.isOnHold = false;
        console.warn("Error attempting to put the call on hold:", error);
    });
}

function unhold(lineNum) {
    console.log('attempt to unhold '+lineNum);
    let session = activeCalls[lineNum];
    if(session == null) { console.log('no valid session'); return; }
    if(session.isOnHold == false) {
        console.log("Call is already off hold:", lineNum);
        return;
    }
    console.log("Taking call off hold:", lineNum);
    session.isOnHold = false;

    var sessionDescriptionHandlerOptions = session.sessionDescriptionHandlerOptionsReInvite;
    sessionDescriptionHandlerOptions.hold = false;
    session.sessionDescriptionHandlerOptionsReInvite = sessionDescriptionHandlerOptions;

    var options = {
        requestDelegate: {
            onAccept: function(){
                if(session && session.sessionDescriptionHandler && session.sessionDescriptionHandler.peerConnection){
                    var pc = session.sessionDescriptionHandler.peerConnection;
                    // Restore all the inbound streams
                    pc.getReceivers().forEach(function(RTCRtpReceiver){
                        if (RTCRtpReceiver.track) RTCRtpReceiver.track.enabled = true;
                    });
                    // Restorte all the outbound streams
                    pc.getSenders().forEach(function(RTCRtpSender){
                        // Unmute Audio
                        if(RTCRtpSender.track && RTCRtpSender.track.kind == "audio") {
                            if(RTCRtpSender.track.IsMixedTrack == true){
                                if(session.sessdata.AudioSourceTrack && session.sessdata.AudioSourceTrack.kind == "audio"){
                                    console.log("Unmuting Mixed Audio Track : "+ session.sessdata.AudioSourceTrack.label);
                                    session.sessdata.AudioSourceTrack.enabled = true;
                                }
                            }
                            console.log("Unmuting Audio Track : "+ RTCRtpSender.track.label);
                            RTCRtpSender.track.enabled = true;
                        }
                        else if(RTCRtpSender.track && RTCRtpSender.track.kind == "video") {
                            RTCRtpSender.track.enabled = true;
                        }
                    });
                }
                session.isOnHold = false;
                console.log("Call is off hold:", lineNum);

            },
            onReject: function(){
                session.isOnHold = true;
                console.warn("Failed to put the call off hold", lineNum);
            }
        }
    };
    session.invite(options).catch(function(error){
        session.isOnHold = true;
        console.warn("Error attempting to take to call off hold", error);
    });
}

function hangup(lineNum) {
    console.log('attempt to hangup '+lineNum);
    let session = activeCalls[lineNum];
    if(session == null) { console.log('no valid sesion'); return; }
    console.log('hangup active call id '+session._id);
    switch(session.state) {
      case SIP.SessionState.Initial:
      case SIP.SessionState.Establishing:
        if (session.Inviter) {
          // An unestablished outgoing session
          session.cancel();
          // stop progress sound 
          const el = document.getElementById('ringing');
          el.pause();
        } else {
          // An unestablished incoming session
          session.reject();
        }
        break;
      case SIP.SessionState.Established:
        // An established session
        session.bye();
        break;
      case SIP.SessionState.Terminating:
      case SIP.SessionState.Terminated:
        // Cannot terminate a session that is already terminated
        break;
    }
}

function mute(lineNum){
    let session = activeCalls[lineNum];
    if(session == null) { console.log('no valid session'); return; }
    session.isMuted=true;

    var pc = session.sessionDescriptionHandler.peerConnection;
    pc.getSenders().forEach(function (RTCRtpSender) {
        if(RTCRtpSender.track && RTCRtpSender.track.kind == "audio") {
            if(RTCRtpSender.track.IsMixedTrack == true){
                if(session.sessdata.AudioSourceTrack && session.sessdata.AudioSourceTrack.kind == "audio"){
                    console.log("Muting Mixed Audio Track : "+ session.sessdata.AudioSourceTrack.label);
                    session.sessdata.AudioSourceTrack.enabled = false;
                }
            }
            console.log("Muting Audio Track : "+ RTCRtpSender.track.label);
            RTCRtpSender.track.enabled = false;
        }
    });
}

function unmute(lineNum){
    let session = activeCalls[lineNum];
    if(session == null) { console.log('no valid session'); return; }
    session.isMuted=false;

    var pc = session.sessionDescriptionHandler.peerConnection;
    pc.getSenders().forEach(function (RTCRtpSender) {
        if(RTCRtpSender.track && RTCRtpSender.track.kind == "audio") {
            if(RTCRtpSender.track.IsMixedTrack == true){
                if(session.sessdata.AudioSourceTrack && session.sessdata.AudioSourceTrack.kind == "audio"){
                    console.log("Unmuting Mixed Audio Track : "+ session.sessdata.AudioSourceTrack.label);
                    session.sessdata.AudioSourceTrack.enabled = true;
                }
            }
            console.log("Unmuting Audio Track : "+ RTCRtpSender.track.label);
            RTCRtpSender.track.enabled = true;
        }
    });

}

function dial(number) {

    number = number.trim();

    // Add dialed number to call list
    first_option = $("#callhistory option:first").val();
    if(first_option != number) {
        $('#callhistory').prepend("<option value='" + number + "'>");
        if($('#callhistory option').length>10) {
            $('#callhistory option:last').remove();
        }
    }

    if(Object.keys(activeCalls).length>3) {
        console.log("max lines reached");
        setFooterText(parent.lang['reject_max_lines']);
        return;
    }

    const target = SIP.UserAgent.makeURI("sip:"+number+"@"+host);
    if (!target) {
        setFooterText("There was a problem: invalid URI");
        throw new Error("Failed to create target URI.");
    }

    var sdpOptions = {
        earlyMedia: true,
        sessionDescriptionHandlerOptions: {
            constraints: {
                audio: { deviceId : "default" },
                video: false
            }
        }
    }
 
    micDevice = getMicDevice();
    if(micDevice!='default') {
        delete sdpOptions.sessionDescriptionHandlerOptions.constraints.audio;
        sdpOptions.sessionDescriptionHandlerOptions.constraints.audio = {};
        sdpOptions.sessionDescriptionHandlerOptions.constraints.audio.deviceId = { exact: micDevice }
    }

    if(supportedConstraints.autoGainControl) {
        sdpOptions.sessionDescriptionHandlerOptions.constraints.audio.autoGainControl = myAutoGainControl;
    }
    if(supportedConstraints.echoCancellation) {
        sdpOptions.sessionDescriptionHandlerOptions.constraints.audio.echoCancellation = myEchoCancellation;
    }
    if(supportedConstraints.noiseSuppression) {
        sdpOptions.sessionDescriptionHandlerOptions.constraints.audio.noiseSuppression = myNoiseSuppresion;
    }

    next_line = nextLine();
    activeCalls[next_line] = new SIP.Inviter(userAgent, target, sdpOptions);
    activeCalls[next_line].lineNumber = next_line;
    activeCalls[next_line].isOnHold = false;
    activeCalls[next_line].isMuted = false;
    activeCalls[next_line].Inviter = true;
    activeCalls[next_line].localEarlyMedia = false;
    activeCalls[next_line].sessdata = {};
    activeCalls[next_line].sessdata.AudioSourceTrack=null;

    lineObj = activeCalls[next_line];

    // Handle inviter session state changes.
    activeCalls[next_line].stateChange.addListener((newState) => {
        line_no = lineObj.lineNumber;
        switch (newState) {
            case SIP.SessionState.Establishing:
                console.log('inviter addlistener state establishing inviter session '+line_no);
                activeCalls[line_no].startTime = Math.floor(Date.now()/1000);
                selectLine(line_no);
                render();
                disablePhoneActionButtons(line_no);
                break;
            case SIP.SessionState.Established:
                console.log('inviter addlistener state  session established '+line_no);
                activeCalls[line_no].startTime = Math.floor(Date.now()/1000);
                selectLine(line_no);
                render();
                enablePhoneActionButtons(line_no);
                break;
            case SIP.SessionState.Terminated:
                console.log("inviter session terminated "+line_no);
                line_no=0;
                Object.keys(activeCalls).forEach(id => {
                    console.log(id,activeCalls[id]._state);
                    if(activeCalls[id]._state == SIP.SessionState.Terminated) {
                        cleanupMedia(id);
                        line_no=id;
                        setFooterText(sprintf(parent.lang['call_ended_on_line'],line_no));
                        const el = document.getElementById('ringing');
                        if(!el.paused) { el.pause(); }
                    }
                });
                if(line_no>0) {
                    delete activeCalls[line_no];
                    if(selectedLine==line_no) {
                        selectFirstLine();
                    }
                }
                
                render();

                break;
            default:
                break;
        }
    });

    activeCalls[next_line].delegate = {
        onBye: function(sip){
            line_no = find_line_from_id(sip.incomingByeRequest.message.callId+sip.incomingByeRequest.toTag);
            console.log('inviter delegate on bye '+line_no);
            terminate_session(line_no);
        },
        onMessage: function(sip){
            console.log('inviter delegate on message');
        },
        onInvite: function(sip){
            console.log('inviter delgate on reinvite');
        },
        onSessionDescriptionHandler: function(sdh, provisional){
            setSDH(next_line, sdh, provisional, false);
        }
    }
 
    var inviterOptions = {
        requestDelegate: { // OutgoingRequestDelegate
            onTrying: function(sip){
                console.log('inviter ontrying... do nothing');
            },
            onProgress:function(sip){
                console.log('inviter onprogress');
                onInviteProgress(lineObj.lineNumber,sip);
            },
            onRedirect:function(sip){
                console.log('inviter onredirect... do nothing');
            },
            onAccept:function(sip){
                console.log('inviter onaccept (pause progress sound)');
                el = document.getElementById('ringing');
                el.pause();
            },
            onReject:function(sip){
                console.log(sip);
                //line_no = find_line_from_id(sip.incomingByeRequest.message.callId+sip.incomingByeRequest.toTag);   
//                console.log('inviter on reject (terminate call) find '+line_no+' and line number '+lineObj.lineNumber);
                terminate_session(lineObj.lineNumber);
            }
        }
    }
    activeCalls[next_line].invite(inviterOptions)
    .then((pp) => {
      // nada
    })
    .catch((error) => {
        // INVITE did not send
        delete activeCalls[next_line];
        if(selectedLine==next_line) {
            selectFirstLine();
        }
        render();
    });
}

function terminate_session(line_no) {
    console.log('terminate session '+line_no);
    cleanupMedia(line_no);
    setFooterText(sprintf(parent.lang['call_ended_on_line'],line_no));
    const el = document.getElementById('ringing');
    if(!el.paused) { el.pause(); }
    delete activeCalls[line_no];
    if(selectedLine==line_no) {
        selectFirstLine();
    }
    render();
}

function setSDH(line_no, sdh, provisional, withVideo){
    if (sdh) {
        if(sdh.peerConnection){
            sdh.peerConnection.ontrack = function(event){
                setupRemoteMedia(line_no,sdh);
            }
        }
    }
}

function setupRemoteMedia(line_no,sdh) {
    const mediaElement = document.getElementById('remoteAudio'+line_no);
    const remoteStream = new MediaStream();
    //session.sdh.peerConnection.getReceivers().forEach((receiver) => {
    sdh.peerConnection.getReceivers().forEach((receiver) => {
        if (receiver.track) {
            if(receiver.track.kind == "audio"){
                remoteStream.addTrack(receiver.track);
            }
        }
    });
    mediaElement.srcObject = remoteStream;
    mediaElement.setSinkId(getSpeakerDevice());
    mediaElement.play().catch(function() { console.log('setup remote media error playing audio');});
}

function cleanupMedia(line_no) {
    var session = activeCalls[line_no];
    if(session==null) { return; }
    if(session.sessdata.AudioSourceTrack && session.sessdata.AudioSourceTrack.kind == "audio"){
        session.sessdata.AudioSourceTrack.stop();
        session.sessdata.AudioSourceTrack = null;
    }
    const mediaElement = document.getElementById('remoteAudio'+line_no);
    mediaElement.srcObject = null;
    mediaElement.pause();
}

function blind_transfer(line_no,number) {
    console.log("attempt blind transfer line "+line_no+" to "+number);
    var transferOptions  = {
        requestDelegate: {
            onAccept: function(sip){
                console.log("Blind transfer Accepted");
                activeCalls[line_no].bye().catch(function(error){
                    console.warn("Could not BYE after blind transfer:", error);
                });
            },
            onReject:function(sip){
                console.warn("REFER rejected:", sip);
                // Session should still be up, so just allow them to try again
            }
        }
    }

    const target = SIP.UserAgent.makeURI('sip:'+number+'@'+host);
    activeCalls[line_no].refer(target, transferOptions).catch(function(error){
        console.warn("Failed to REFER", error);
    });;

}

function supervised_transfer(line_no,number) {

    console.log("attempt supervisedtransfer line "+line_no+" to "+number);
    var session = activeCalls[line_no];

    // SDP options
    var sdpOptions = {
        earlyMedia: true,
        sessionDescriptionHandlerOptions: {
            constraints: {
                audio: { deviceId : "default" },
                video: false
            }
        }
    }

    speakerDevice = getMicDevice();
    if(speakerDevice != 'default') {
        console.log(speakerDevice);
        sdpOptions.sessionDescriptionHandlerOptions.constraints.audio.deviceId = { exact: speakerDevice }
    }

    var targetURI = SIP.UserAgent.makeURI("sip:"+ number + "@" + host);
    var newSession = new SIP.Inviter(userAgent, targetURI, sdpOptions);
    newSession.delegate = {
        onBye: function(bye){
            console.log("Transfer call session ended with BYE");
            setStatusText("");
            setFooterText(parent.lang['transfer_finished']);
            line_no = 0;
            $('.transferbox').each(function() {
                if($(this).is(':visible')) {
                    line_no = $(this).attr('id').substr(12);
                }
            });
            if(line_no>0) {
                $('#transferbox_'+line_no).slideUp();
                $('#actionbuttons_'+line_no).slideDown();
                unhold(line_no);
                render();
            }
        },
        onSessionDescriptionHandler: function(sdh, provisional){
            if (sdh) {
                if(sdh.peerConnection){
                    sdh.peerConnection.ontrack = function(event){
                        var pc = sdh.peerConnection;

                        // Gets Remote Audio Track (Local audio is setup via initial GUM)
                        var remoteStream = new MediaStream();
                        pc.getReceivers().forEach(function (receiver) {
                            if(receiver.track && receiver.track.kind == "audio"){
                                remoteStream.addTrack(receiver.track);
                            }
                        });
                        var remoteAudio = $("#remoteAudio"+line_no+"-transfer")[0];
                        remoteAudio.srcObject = remoteStream;
                        remoteAudio.onloadedmetadata = function(e) {
                            if (typeof remoteAudio.sinkId !== 'undefined') {
                                speakerDevice = getSpeakerDevice();
                                remoteAudio.setSinkId(speakerDevice).then(function(){
                                    console.log("sinkId applied: "+speakerDevice );
                                }).catch(function(e){
                                    console.warn("Error using setSinkId: ", e);
                                });
                            }
                            remoteAudio.play().catch(function() { console.log('error playing remote audio');});
                        }
                    }
                }
            }
        }
    }
//    session.childsession = newSession;
    var inviterOptions = {
        requestDelegate: {
            onTrying: function(sip){
                setStatusText(sprintf(parent.lang.trying,''));
            },
            onProgress:function(sip){
                setStatusText(parent.lang.ringing);

                var CancelAttendedTransferBtn = $('#btncasutrans_'+line_no);
                CancelAttendedTransferBtn.off('click');
                CancelAttendedTransferBtn.on('click', function(){
                    if(newSession._state == SIP.SessionState.Established) {
                        newSession.bye().catch(function(error){
                            console.warn("Failed to BYE", error);
                        });
                        setStatusText(parent.lang['transfer_cancelled']);
                        selectLine(selectedLine);
                        render();
                    } else if(newSession._state == SIP.SessionState.Establishing) {
                        newSession.cancel().catch(function(error){
                            console.warn("Failed to CANCEL", error);
                        });
                        setStatusText(parent.lang['transfer_cancelled']);
                        selectLine(selectedLine);
                        render();
                    }
                });
            },
            onRedirect:function(sip){
                console.log("Redirect received:", sip);
            },
            onAccept:function(sip){
                setStatusText(sprintf(parent.lang['call_progress_line'],line_no));
                $('#transferbox_'+line_no).show();
                var CompleteTransferBtn = $("#btncomplete_"+line_no);
                CompleteTransferBtn.off('click');
                CompleteTransferBtn.on('click', function(){
                    var transferOptions  = {
                        requestDelegate: {
                            onAccept: function(sip){
                                setStatusText(parent.lang['supervised_transfer_accepted']);

                                // We must end this session manually
                                session.bye().catch(function(error){
                                    console.warn("Could not BYE after supervised transfer:", error);
                                });

                            },
                            onReject: function(sip){
                                setStatusText(parent.lang['supervised_transfer_failed']);
                            }
                        }
                    }

                    // Send REFER
                    session.refer(newSession, transferOptions).catch(function(error){
                        console.warn("Failed to REFER", error);
                    });

                    setStatusText(parent.lang['supervised_transfer_complete']);
                    render();
                });

                var btncancelsupervisedtransfer = $("#btncasutrans-"+ line_no);
                btncancelsupervisedtransfer.off('click');
                btncancelsupervisedtransfer.on('click', function(){
                    newSession.bye().catch(function(error){
                        console.warn("Failed to BYE", error);
                    });
                    setStatusText(parent.lang['call_ended']);

                });
                $('.transfer_stage1').hide();
                $('.transfer_stage2').show();

            },
            onReject:function(sip){
                console.log("New call session rejected: ", sip.message.reasonPhrase);
                setStatusText(parent.lang['call_rejected']);
                render();
            }
        }
    }
    newSession.invite(inviterOptions).catch(function(e){
        console.warn("Failed to send INVITE:", e);
    });
}

function cancel_conference(line_no){
    var session = activeCalls[line_no];
    if(session == null) { return; }
    if(session.sessdata.childsession){
        console.log("Child Conference call detected:", session.sessdata.childsession.state);
        session.sessdata.childsession.dispose().then(function(){
            session.sessdata.childsession = null;
        }).catch(function(error){
            session.sessdata.childsession = null;
        });
    }
    unhold(line_no);
}


function conference(line_no,number) {

    var session = activeCalls[line_no];
    if(!session.sessdata.confcalls) session.sessdata.confcalls = [];
    session.sessdata.confcalls.push({
        to: number,
        startTime: new Date().toISOString(),
        disposition: "invite",
        dispositionTime: new Date().toISOString(),
        accept : {
            complete: null,
            eventTime: null,
            disposition: ""
        }
    });

    var confcallid = 0;

    var participant_1 = activeCalls[line_no].remoteIdentity.uri.raw.user;

    // SDP options
    var sdpOptions = {
        earlyMedia: true,
        sessionDescriptionHandlerOptions: {
            constraints: {
                audio: { deviceId : "default" },
                video: false
            }
        }
    }

    speakerDevice = getMicDevice();
    if(speakerDevice != 'default') {
        console.log(speakerDevice);
        sdpOptions.sessionDescriptionHandlerOptions.constraints.audio.deviceId = { exact: speakerDevice }
    }

    if(supportedConstraints.autoGainControl) {
        sdpOptions.sessionDescriptionHandlerOptions.constraints.audio.autoGainControl = myAutoGainControl;
    }
    if(supportedConstraints.echoCancellation) {
        sdpOptions.sessionDescriptionHandlerOptions.constraints.audio.echoCancellation = myEchoCancellation;
    }
    if(supportedConstraints.noiseSuppression) {
        sdpOptions.sessionDescriptionHandlerOptions.constraints.audio.noiseSuppression = myNoiseSuppresion;
    }

    // Create new call session
    console.log("CONFERENCE INVITE: ", "sip:" + number + "@" + host);

    var targetURI = SIP.UserAgent.makeURI("sip:"+ number + "@" + host);
    var newSession = new SIP.Inviter(userAgent, targetURI, sdpOptions);
    newSession.sessdata = {}

    newSession.delegate = {
        onBye: function(sip){
            console.log("New call session ended with BYE");
            setStatusText("");
            setFooterText(parent.lang['conference_done']);
            line_no = 0;
            $('.conferencebox').each(function() {
                if($(this).is(':visible')) {
                    console.log($(this).attr('id'));
                    line_no = $(this).attr('id').substr(14);
                    console.log(line_no);
                }
            });
            if(line_no>0) {
                $('#conferencebox_'+line_no).slideUp();
                $('#actionbuttons_'+line_no).slideDown();
                unhold(line_no);
                render();
            }
        },
        onSessionDescriptionHandler: function(sdh, provisional){
            if (sdh) {
                if(sdh.peerConnection){
                    sdh.peerConnection.ontrack = function(event){
                        var pc = sdh.peerConnection;

                        // Gets Remote Audio Track (Local audio is setup via initial GUM)
                        var remoteStream = new MediaStream();
                        pc.getReceivers().forEach(function (receiver) {
                            if(receiver.track && receiver.track.kind == "audio"){
                                remoteStream.addTrack(receiver.track);
                            }
                        });
                        var remoteAudio = $("#remoteAudio"+line_no+"-conference")[0];
                        remoteAudio.srcObject = remoteStream;
                        remoteAudio.onloadedmetadata = function(e) {
                            if (typeof remoteAudio.sinkId !== 'undefined') {
                                speakerDevice = getSpeakerDevice();
                                remoteAudio.setSinkId(speakerDevice).then(function(){
                                    console.log("sinkId applied: "+ speakerDevice);
                                }).catch(function(e){
                                    console.warn("Error using setSinkId: ", e);
                                });
                            }
                            remoteAudio.play().catch(function() { console.log('error playing remote audio');});
                        }
                    }
                }
            }
        }
    }
    // Make sure we always restore audio paths
    newSession.stateChange.addListener(function(newState){
        if (newState == SIP.SessionState.Terminated) {
            // Ends the mixed audio, and releases the mic
            if(session.sessdata.childsession.sessdata.AudioSourceTrack && session.sessdata.childsession.sessdata.AudioSourceTrack.kind == "audio"){
                session.sessdata.childsession.sessdata.AudioSourceTrack.stop();
            }
            // Restore Audio Stream as it was changed
            if(session.sessdata.AudioSourceTrack && session.sessdata.AudioSourceTrack.kind == "audio"){
                var pc = session.sessionDescriptionHandler.peerConnection;
                pc.getSenders().forEach(function (RTCRtpSender) {
                    if(RTCRtpSender.track && RTCRtpSender.track.kind == "audio") {
                        RTCRtpSender.replaceTrack(session.sessdata.AudioSourceTrack).then(function(){
                            if(session.isMuted){
                                RTCRtpSender.track.enabled = false;
                            }
                            else {
                                RTCRtpSender.track.enabled = true;
                            }
                        }).catch(function(){
                            console.error(e);
                        });
                        session.sessdata.AudioSourceTrack = null;
                    }
                });
            }
        }
    });

    session.sessdata.childsession = newSession;

    var inviterOptions = {
        requestDelegate: {
            onTrying: function(sip){
                var txtstatus = sprintf(parent.lang.trying,'');
                setStatusText(txtstatus);
                session.sessdata.confcalls[confcallid].disposition = "trying";
                session.sessdata.confcalls[confcallid].participant1 = participant_1;
                session.sessdata.confcalls[confcallid].participant2 = number;
                session.sessdata.confcalls[confcallid].txtstatus = txtstatus;
                session.sessdata.confcalls[confcallid].dispositionTime = new Date().toISOString();
            },
            onProgress:function(sip){
                var txtstatus = parent.lang.ringing;
                setStatusText(txtstatus);
                session.sessdata.confcalls[confcallid].disposition = "progress";
                session.sessdata.confcalls[confcallid].txtstatus = txtstatus;
                session.sessdata.confcalls[confcallid].dispositionTime = new Date().toISOString();
        
                $('.conference_stage1').hide();

                var btncancelconf = $('#btncajoinconf_'+line_no);
                btncancelconf.off('click');
                btncancelconf.on('click', function(){
                    newSession.cancel().catch(function(error){
                        console.warn("Failed to CANCEL", error);
                    });
                    var txtstatus = parent.lang.call_ended
                    setStatusText(txtstatus);
                    console.log("New call session canceled");
                    session.sessdata.confcalls[confcallid].accept.complete = false;
                    session.sessdata.confcalls[confcallid].accept.disposition = "cancel";
                    session.sessdata.confcalls[confcallid].txtstatus = txtstatus;
                    session.sessdata.confcalls[confcallid].accept.eventTime = new Date().toISOString();
        
                });
                btncancelconf.show();

            },
            onRedirect:function(sip){
                console.log("Redirect received:", sip);
            },
            onAccept:function(sip){
                $('.conference_stage1').hide();
                $('.conference_stage2').show();
                var txtstatus = parent.lang['call_in_progress'];
                setStatusText(txtstatus);
                session.sessdata.confcalls[confcallid].complete = true;
                session.sessdata.confcalls[confcallid].disposition = "accepted";
                session.sessdata.confcalls[confcallid].dispositionTime = new Date().toISOString();
                session.sessdata.confcalls[confcallid].txtstatus = txtstatus;

                $('#conftarget_'+line_no).hide();

                // Join Call
                var btnjoinconference = $("#btnjoin_"+ line_no);
                btnjoinconference.off('click');
                btnjoinconference.on('click', function(){
                    // Merge Call Audio
                    if(!session.sessdata.childsession){
                        console.warn("Conference session lost");
                        return;
                    }

                    var outputStreamForSession = new MediaStream();
                    var outputStreamForConfSession = new MediaStream();

                    var pc = session.sessionDescriptionHandler.peerConnection;
                    console.log(session.sessdata);
                    var confPc = session.sessdata.childsession.sessionDescriptionHandler.peerConnection;

                    // Get conf call input channel
                    confPc.getReceivers().forEach(function (RTCRtpReceiver) {
                        if(RTCRtpReceiver.track && RTCRtpReceiver.track.kind == "audio") {
                            console.log("Adding conference session:", RTCRtpReceiver.track.label);
                            outputStreamForSession.addTrack(RTCRtpReceiver.track);
                        }
                    });

                    // Get session input channel
                    pc.getReceivers().forEach(function (RTCRtpReceiver) {
                        if(RTCRtpReceiver.track && RTCRtpReceiver.track.kind == "audio") {
                            console.log("Adding conference session:", RTCRtpReceiver.track.label);
                            outputStreamForConfSession.addTrack(RTCRtpReceiver.track);
                        }
                    });

                    // Replace tracks of Parent Call
                    pc.getSenders().forEach(function (RTCRtpSender) {
                        if(RTCRtpSender.track && RTCRtpSender.track.kind == "audio") {
                            console.log("Switching to mixed Audio track on session");
        
                            session.sessdata.AudioSourceTrack = RTCRtpSender.track;
                            outputStreamForSession.addTrack(RTCRtpSender.track);
                            var mixedAudioTrack = MixAudioStreams(outputStreamForSession).getAudioTracks()[0];
                            mixedAudioTrack.IsMixedTrack = true;

                            RTCRtpSender.replaceTrack(mixedAudioTrack);
                        }
                    });
                    // Replace tracks of Child Call
                    confPc.getSenders().forEach(function (RTCRtpSender) {
                        if(RTCRtpSender.track && RTCRtpSender.track.kind == "audio") {
                            console.log("Switching to mixed Audio track on conf call");
        
                            session.sessdata.childsession.sessdata.AudioSourceTrack = RTCRtpSender.track;
                            outputStreamForConfSession.addTrack(RTCRtpSender.track);
                            var mixedAudioTrackForConf = MixAudioStreams(outputStreamForConfSession).getAudioTracks()[0];
                            mixedAudioTrackForConf.IsMixedTrack = true;

                            RTCRtpSender.replaceTrack(mixedAudioTrackForConf);
                        }
                    });
        
                    var txtstatus = sprintf(parent.lang['conference_in_progress'],session.sessdata.confcalls[confcallid].participant1,session.sessdata.confcalls[confcallid].participant2);
                    setStatusText(txtstatus);
                    console.log("Conference in progress");
        
                    session.sessdata.confcalls[confcallid].accept.complete = true;
                    session.sessdata.confcalls[confcallid].accept.disposition = "join";
                    session.sessdata.confcalls[confcallid].accept.eventTime = new Date().toISOString();
                    session.sessdata.confcalls[confcallid].txtstatus = txtstatus;
        
                    btnjoinconference.hide();

                    // Take the parent call off hold after a second
                    window.setTimeout(function(){
                        console.log("unhold "+line_no);
                        unhold(line_no);
                    }, 1000);
                });
                btnjoinconference.show();

                // End Call
                var TerminateConfCallBtn = $("#btnfinishconf_"+line_no);
                TerminateConfCallBtn.off('click');
                TerminateConfCallBtn.on('click', function(){
                    newSession.bye().catch(function(e){
                        console.warn("Failed to BYE", e);
                    });
                    var txtstatus = parent.lang.call_ended;
                    setStatusText(txtstatus);
                    console.log("New call session end");

                    // session.data.confcalls[confcallid].accept.complete = false;
                    session.sessdata.confcalls[confcallid].accept.disposition = "bye";
                    session.sessdata.confcalls[confcallid].accept.eventTime = new Date().toISOString();
                    session.sessdata.confcalls[confcallid].txtstatus = txtstatus;

                    window.setTimeout(function(){
                        cancel_conference(line_no);
                        delete(session.sessdata.confcalls);
                        render();
                    }, 1000);
                });
                TerminateConfCallBtn.show();
                $('#btncaconf_'+line_no).hide();
                $('#btncajoinconf_'+line_no).hide();

            },
            onReject:function(sip){
                console.log("New call session rejected: "+sip.message.reasonPhrase+" on line number"+line_no);
                var txtstatus = parent.lang['call_rejected'];
                setStatusText(txtstatus);
                session.sessdata.confcalls[confcallid].disposition = sip.message.reasonPhrase;
                session.sessdata.confcalls[confcallid].dispositionTime = new Date().toISOString();
                session.sessdata.confcalls[confcallid].txtstatus = txtstatus;
        
                window.setTimeout(function(){
                    $('#conferencebox_'+line_no).slideUp();
                    $('#actionbuttons_'+line_no).slideDown();
                    window.setTimeout(function() { unhold(line_no);render();},500);
                }, 750);
            }
        }
    }
    newSession.invite(inviterOptions).catch(function(e){
        console.warn("Failed to send INVITE:", e);
    });
}

function find_line_from_id(sessionid) {
    var found=0;
    Object.keys(activeCalls).forEach(id => { 
        console.log("find line by id, active call id: "+activeCalls[id]._id+", looking for: "+sessionid);
        if(activeCalls[id]._id == sessionid) {
            found=id;
        }
    });
    return found;
}

function onInviteProgress(line_no,response){
    console.log("Call Progress:", response.message.statusCode);
    // Provisional 1xx
    // response.message.reasonPhrase
    if(response.message.statusCode == 180){
        // Play Early Media
        if(activeCalls[line_no].localEarlyMedia) {
            console.log("Early media already playing");
        }
        else {
            el = document.getElementById('ringing');
            if (typeof el.sinkId !== 'undefined' && getSpeakerDevice() != 'default') { 
                el.setSinkId(getSpeakerDevice()).catch(function() { console.log('could not set sinkid');});
            }
            el.currentTime=0;
            el.play().catch(function() { console.log("could not play early media sound"); });
            activeCalls[line_no].localEarlyMedia=true;
        }
    }
    else if(response.message.statusCode === 183){
        setFooterText("183 "+response.message.reasonPhrase);
    }
    else {
        setFooterText(response.message.reasonPhrase);
        // 181 = Call is Being Forwarded
        // 182 = Call is queued (Busy server!)
        // 199 = Call is Terminated (Early Dialog)
    }
}

function populateDevices() {

    if(navigator.mediaDevices) {

        supportedConstraints = navigator.mediaDevices.getSupportedConstraints();

        navigator.mediaDevices.enumerateDevices().then(function(deviceInfos){

            var savedAudioDevice = getMicDevice();
            var audioDeviceFound = false;

            var MicrophoneFound = false;
            var SpeakerFound    = false;

            for (var i = 0; i < deviceInfos.length; ++i) {
                console.log("Found Device ("+ deviceInfos[i].kind +"): ", deviceInfos[i].label);

                // Check Devices
                if (deviceInfos[i].kind === "audioinput") {
                    MicrophoneFound = true;
                    if(savedAudioDevice != "default" && deviceInfos[i].deviceId == savedAudioDevice) {
                        audioDeviceFound = true;
                    }
                }
                else if (deviceInfos[i].kind === "audiooutput") {
                    SpeakerFound = true;
                }
            }

            var constraints = {
                audio: MicrophoneFound,
                video: false
            }

            if (MicrophoneFound) {
                constraints.audio = { deviceId: "default" }
                if(audioDeviceFound) constraints.audio.deviceId = { exact: savedAudioDevice }
            }

            navigator.mediaDevices.getUserMedia(constraints).then( function(mediaStream) {

                // Handle Audio
                var audioTrack = (mediaStream.getAudioTracks().length >= 1)? mediaStream.getAudioTracks()[0] : null ;
                if(MicrophoneFound && audioTrack != null){
                    // do nothing?  
                } else {
                    setFooterText(parent.lang.nomic);
                }
                if(!SpeakerFound){
                    setFooterText(parent.lang.nospeaker);
                }

                // Return .then()
                return navigator.mediaDevices.enumerateDevices();

            }).then(function(deviceInfos){
                for (var i = 0; i < deviceInfos.length; ++i) {
                    console.log("Found Device ("+ deviceInfos[i].kind +") Again: ", deviceInfos[i].label, deviceInfos[i].deviceId);

                    var deviceInfo = deviceInfos[i];
                    var deviceId = deviceInfo.deviceId;
                    var DisplayName = deviceInfo.label;
                    if(DisplayName.indexOf("(") > 0) DisplayName = DisplayName.substring(0,DisplayName.indexOf("("));

                    if (deviceInfo.kind === "audioinput") {
                        dname = (DisplayName != "")? DisplayName : "Microphone";
                        dsel = false;
                        if(getMicDevice() == deviceId) dsel = true;

                        $('#microphoneSrc').append($('<option>', {
                            value: deviceId,
                            text: DisplayName,
                            selected: dsel
                        }));

                    }
                    else if (deviceInfo.kind === "audiooutput") {
                        dname = (DisplayName != "")? DisplayName : "Speaker";
                        dsel = false;
                        if(getSpeakerDevice() == deviceId) dsel = true;

                        $('#playbackSrc').append($('<option>', {
                            value: deviceId,
                            text: DisplayName,
                            selected: dsel
                        }));

                        dsel = false;
                        if(getRingerDevice() == deviceId) dsel=true;
                        $('#ringDevice').append($('<option>', {
                            value: deviceId,
                            text: DisplayName,
                            selected: dsel
                        }));


                    }
                }
            }).catch(function(e){
                console.error(e);
                alert('error user media');
            });
       });
    }
}

function displayMeter() {

    stopMicrophoneMeterStream();

    localMicrophoneStream = new MediaStream();

    var constraints = {
        audio: { deviceId: { exact: getMicDevice() } },
        video: false
    }

    navigator.mediaDevices.getUserMedia(constraints).then( function(mediaStream) {
    var audioTrack = (mediaStream.getAudioTracks().length >= 1)? mediaStream.getAudioTracks()[0] : null ;
    if(audioTrack != null){

        localMicrophoneStream.addTrack(audioTrack);
        const instantMeter = document.querySelector('#instant meter');
        window.AudioContext = window.AudioContext || window.webkitAudioContext;
        window.audioContext = new AudioContext();
        const soundMeter = window.soundMeter = new SoundMeter(window.audioContext);
        soundMeter.connectToSource(localMicrophoneStream, function(e) {
        if (e) {
            alert(e);
            return;
        }
        setInterval(() => {
              instantMeter.value = soundMeter.instant.toFixed(2);
            }, 200);
        });
    }
    });
}

function stopMicrophoneMeterStream() {
    if(typeof(localMicrophoneStream)!='undefined') {
        localMicrophoneStream.getTracks().forEach(track => track.stop());
    }
}

function getRingtone() {
    var rt = localStorage.getItem("ringtone");
    return (rt != null)? rt : 'incoming1';
}

function getNoiseSuppresion() {
    var ns = localStorage.getItem("NoiseSuppresion");
    return (ns != null)? ns : true;
}

function getAutoGainControl() {
    var ns = localStorage.getItem("AutoGainControl");
    return (ns != null)? ns : true;
}

function getEchoCancellation() {
    var ns = localStorage.getItem("EchoCancellation");
    return (ns != null)? ns : true;
}

function getMicDevice() {
    var id = localStorage.getItem("MicDevice");
    return (id != null)? id : "default";
}

function getRingerDevice() {
    var id = localStorage.getItem("RingerDevice");
    return (id != null)? id : "default";
}

function getSpeakerDevice() {
    var id = localStorage.getItem("SpeakerDevice");
    return (id != null)? id : "default";
}

function getIntercom() {
    var id = localStorage.getItem("intercom");
    return (id != null)? id : "on";
}

function getCallwaiting() {
    var id = localStorage.getItem("callwaiting");
    return (id != null)? id : "on";
}

function getAutoanswer() {
    var id = localStorage.getItem("autoanswer");
    return (id != null)? id : "off";
}

// Function which recursively attempts reconnection
const orig_attemptReconnection = (reconnectionAttempt = 1) => {
  // If not intentionally connected, don't reconnect.
  if (!shouldBeConnected) {
    return;
  }

  // Reconnection attempt already in progress
  if (attemptingReconnection) {
    return;
  }

  // Reconnection maximum attempts reached
  if (reconnectionAttempt > reconnectionAttempts) {
    return;
  }

  // We're attempting a reconnection
  attemptingReconnection = true;

  setTimeout(() => {
    // If not intentionally connected, don't reconnect.
    if (!shouldBeConnected) {
      attemptingReconnection = false;
      return;
    }
    // Attempt reconnect
    userAgent.reconnect()
      .then(() => {
        // Reconnect attempt succeeded
        attemptingReconnection = false;
      })
      .catch((error) => {
        // Reconnect attempt failed
        attemptingReconnection = false;
        attemptReconnection(++reconnectionAttempt);
      });
  }, reconnectionAttempt === 1 ? 0 : reconnectionDelay * 1000);
};

window.addEventListener("online", () => {
    attemptReconnection();
});


function attemptReconnection() {
    if(attemptingReconnection) return;
    if(reconnectingAttempts <= 0) return;

    attemptingReconnection = true

    window.setTimeout(function(){
        setFooterText(parent.lang.connectingwebsocket);
        userAgent.reconnect().then(function(){
            console.log("Reconnected to websocket");
            reconnectingAttempts = reconnectionAttempts;
            attemptingReconnection = false;
            transportConnected()
            onRegistration();
        }).catch(function(error){
            attemptingReconnection = false
            setFooterText(parent.lang.websocketconnectionfailed);
            transportConnectError(error);
        });
    }, 5000);
    setFooterText(parent.lang.connectingwebocket);
    reconnectingAttempts--;
}

function transportConnected() {
    if(failinsecure==false) {
        console.log("Connected to websocket");
        setFooterText(parent.lang.connectedwebsocket);
        reconnectingAttempts = reconnectionAttempts;
        if(attemptingReconnection == false && registering == false){
            window.setTimeout(function (){
                console.log("about to call register on transport connected");
                register();
            }, 500);
        }
    } else {
        renderRegister("unregistered");
        setFooterText(parent.lang.usehttps);
    }
}

function register() {
    console.log('registerer register');
    if (registering == true || userAgent.isRegistered() && userAgent.isConnected()) { console.log('ya esta registrado, do nothing'); return; }
    var registererRegisterOptions = {
        requestDelegate: {
            onReject: function(sip){
                registerFailed(sip.message.reasonPhrase, sip.message.statusCode);
            }
        }
    }
    setFooterText(parent.lang.registering);
    registering = true
    registerer.register(registererRegisterOptions);
}

function unregister() {
    if (!userAgent.isRegistered()) return;

    console.log("registerer Unregistering...");
    setFooterText(parent.lang.unregistering);
    registerer.unregister();
    attemptingReconnection = false;
    registering = false;
}

function registerFailed(response, cause){
    console.log("registerer Registration failed: " + response);
    setFooterText(sprintf(parent.lang.registrationfailed,response));
    renderRegister("unregistered");
    registering = false;
}

function onRegistration() {
    console.log("registerer on registration function");
    registrationCompleted = true;
    registering = false;
    renderRegister('registered');
    setFooterText(parent.lang.registered);

    subscribeBLF();

}

function subscribeBLF() {

    if(blf!==null) {
        for(a=0;a<Object.keys(blf).length;a++) {
            var code = Object.keys(blf)[a];
            const eventType = "presence";
            const targetURI = new SIP.URI("sip", code, host);
            if (targetURI) {

                var dialogOptions = { expires: 300, extraHeaders: ['Accept: application/pidf+xml'] }

                if(typeof(subscriber[code])=='undefined') {

                    subscriber[code] = new SIP.Subscriber(userAgent, targetURI, eventType, dialogOptions);

                    subscriber[code].delegate = {
                        onNotify: (notification) => {
                            notification.accept();
                            var xml = $($.parseXML(notification.request.body));

                            var presence = xml.find("presence").find("note").text();
                            var mydndcode = dndcode + extension;
                            var myqueuelogincode = queuelogincode + '*' + extension;

                            var final_blfid = '';
                            xml.find("presence").find("tuple").each(
                                function(i,element) { 
                                    var blfid = $(element).attr("id");
                                    if(blfid.indexOf("digium")>-1) {
                                        var type = $(element).find('status').find('digium_presence').attr('type');
                                        if(type=="dnd") {
                                            presence="dnd";
                                        }

                                    } else {
                                        if(blfid==mydndcode) {
                                            // Its a DND subscription
                                            if(presence=='On the phone') {
                                                $('#dndbadge').removeClass('badge-success').addClass('badge-danger');
                                            } else {
                                                $('#dndbadge').removeClass('badge-danger').addClass('badge-success');
                                            }
                                        } else if(blfid==myqueuelogincode) {
                                            if(presence=='On the phone') {
                                                // logged into queues
                                                $('#qloginbadge').removeClass('badge-success').addClass('badge-danger').text(parent.lang.logout);
                                            } else {
                                                // not logged into queues
                                                $('#qloginbadge').removeClass('badge-danger').addClass('badge-success').text(parent.lang.login);
                                            }
                                        } else {
                                            final_blfid = blfid;
                                            console.log("availability "+blf[blfid]+"="+presence);

                                            //setBLF(blfid,presence);
                                        }
                                    }
                                }
                            );
                            if($('#contact_internal_'+final_blfid+'_internal').length>0) {
                                presence_class = presence.replace(/\s+/g,'').toLowerCase();
                                possible_class = ['ready','unavailable','onthephone','dnd'];
                                possible_class.map(
                                    function(el,id) { 
                                        if(el!=presence_class) { 
                                            $('#contact_internal_'+final_blfid+'_internal').removeClass(el);
                                        }
                                    }
                                );
                                //$('#contact_'+final_blfid).removeClass('ready').removeClass('unavailable').removeClass('onthephone').removeClass('dnd');
                                $('#contact_internal_'+final_blfid+'_internal').addClass(presence_class);
                                enablePhoneActionButtons(final_blfid);
                                console.log("set "+final_blfid+" to "+presence_class);
                            }

                        }
                    }
                }
                subscriber[code].subscribe();
            }
        }
    }
}

function onUnregistration(){
    if(registrationCompleted){
        registrationCompleted = true;
        registering = false;
        renderRegister('unregistered');
        setFooterText(parent.lang.unregistered);
    }
}

function transportConnectError(error){
    console.warn("Websocket connection failed", error);
    attemptReconnection();
}

function MixAudioStreams(MultiAudioTackStream){

    var audioContext = null;
    try {
        window.AudioContext = window.AudioContext || window.webkitAudioContext;
        audioContext = new AudioContext();
    }
    catch(e){
        console.warn("AudioContext() not available, cannot record");
        return MultiAudioTackStream;
    }
    var mixedAudioStream = audioContext.createMediaStreamDestination();
    MultiAudioTackStream.getAudioTracks().forEach(function(audioTrack){
        var srcStream = new MediaStream();
        srcStream.addTrack(audioTrack);
        var streamSourceNode = audioContext.createMediaStreamSource(srcStream);
        streamSourceNode.connect(mixedAudioStream);
    });

    return mixedAudioStream.stream;
}

function sendSIPMessage(exten, msg, channel) {

    console.log("send sip message to "+exten+" on channel "+channel);

    var msgid = uuidv4();

    printMessageOut(exten,msg,msgid).then(function(queuemsgid) {

        var options = {
            requestDelegate : {
                onAccept: function(sip){
                    console.log("Message Accepted:", msgid);
                    console.log(sip);
                    console.log("sip message totag: "+sip.message.toTag);
                    console.log("msgid: "+msgid);
                    console.log("queuemsgid: "+queuemsgid);
                    //nico
                    relateMessageToTag(msgid,sip.message.toTag);
                    markMessageOk(msgid);
                },
                onReject: function(sip){
                    console.warn("Message Error", sip.message.reasonPhrase);
                    relateMessageToTag(msgid,sip.message.toTag);
                    markMessageFail(msgid);
                }
            },
            requestOptions : {
                extraHeaders: [],
            }
        };

        if(msg=='') msg=' ';

        // Escape message to avoid breaking asterisk agi parameters syntax
        msg = msg.replace(/\\/g, '\\\\');
        msg = msg.replace(/"/g, '\\"');

        var targetURI = SIP.UserAgent.makeURI("sip:"+ exten + "@" + host);
        var newmsg = new SIP.Messager(userAgent, targetURI, msg, "text/plain", { extraHeaders: ['X-Queue-Id: '+queuemsgid, 'X-Msg-Id: '+msgid, 'X-Channel: '+channel]});
        console.log("send sip message queue id "+queuemsgid+", channel "+channel+", target uri "+targetURI);
        newmsg.message(options).then(function(){});
    });
    
}


$(window).on("beforeunload", function() {
    console.log("page on before unload registered");
    unregister();
});
